
function pqstatusinit() {
    $.getJSON("/json.do?_INIT_CUSTOMKEY,", (data) => {
        buildTransientEntry(data);
        // buildTransientEntry must complete before data for counts can be displayed properly
        geteventtranscnt();
    });

    // Aways get IEC61000-2-4 Indication
    getiecindicationandreport();

    // Vary between displaying IEEE519 or EN50160 App
    var IEEE519ArtNr = '5100999';
    // Check if IEEE519 is installed
    if (eggs.filter(x => x.appId === IEEE519ArtNr).length > 0) {
        // Only show IEEE519 report row in PQ Overview
        $(".enRepRow").remove();
        $(".enIndRow").remove();
        getieeereport();
    } else {
        // Only show EN50160 rows in PQ Overview
        $(".ieeeRepRow").remove();
        getenindicationandreport();
    }
}


function buildTransientEntry(data) {
    $("#optionalTransientStatus").html("<td><a href=\"transients.html\"><b><span class=\"trans\">" + tl("home.trn24hours") + "</span></b></a></td><td id=\"trncnt\">-</td>");
}


function updateCounters(data, internalUTCAsSeconds) {
    let eventCounter = 0;
    let transientCounter = 0;

    var eventAndTransientData = data.split("-NEXT_ARRAY-");
    var eventData = eval("(" + eventAndTransientData[1] + ")");
    var transientData = eval("(" + eventAndTransientData[2] + ")");

    // create dates now and 24 hours ago
    // Timestamps of event and transient data are in milliseconds
    const presentTime = 1000 * internalUTCAsSeconds;
    // 24 hours * 60 minutes * 60 seconds * 1000 milli
    const oneDayAgo = presentTime - 24 * 60 * 60 * 1000;

    // Count events in the last 24 hours
    for (var i = 0; i < eventData.length; i++) {
        var eventTimeStamp = parseInt(eventData[i].StartTime);
        if (oneDayAgo <= eventTimeStamp && eventTimeStamp < presentTime) {
            eventCounter++;
        }
    }

    // Count transients in the last 24 hours
    for (var i = 0; i < transientData.length; i++) {
        var transientTimeStamp = parseInt(transientData[i].StartTime);
        if (oneDayAgo <= transientTimeStamp && transientTimeStamp < presentTime) {
            transientCounter++;
        }
    }

    //fill values in on page
    if (31 < eventCounter) {
        $("#evtcnt").html("31+");
    } else {
        $("#evtcnt").html(eventCounter);
    }

    if (31 < transientCounter) {
        $("#trncnt").html("31+");
    } else {
        $("#trncnt").html(transientCounter);
    }
}

function geteventtranscnt() {
    $.get("/lib/events/hwwold.html", function (hwwoldData) {
        getInternalUTCAsSeconds(function (utcTime) {
            updateCounters(hwwoldData, utcTime);
        });
    });
}

function getiecindicationandreport() {

    var failure = false;

    //create url with required variables
    var url = url = "../.../.../../../json.do?";
    url += "_ULN_AVG[0..2],_ULL_AVG[0..2],_THD_ULN_AVG[0..2],_FREQ_AVG,_U_SYM_AVG";
    url += ",_FFT_UL1[0..50],_FFT_UL2[0..50],_FFT_UL3[0..50]";
    url += ",_NOMINAL_U[0],_NOMINAL_F,_GBL_IEC_LASTSTATUS,_GBL_IEC_CLASS,";

    //request data
    $.getJSON(url, function (data) {
		
		//Check class from watchdog...
		var iecclass = 2;
		if(data['_GBL_IEC_CLASS'][0] !== "var not found !"){
			iecclass = data['_GBL_IEC_CLASS'][0];
		};

        //determine voltage limits

        var nominalvoltage = data['_NOMINAL_U'][0][0];
        // nominalvoltage on UMG512 is always set to L/N
		if(iecclass === 1){
			var ULNMIN = nominalvoltage - (nominalvoltage * 0.08);
			var ULNMAX = nominalvoltage + (nominalvoltage * 0.08);
			var ULLMIN = (Math.sqrt(3) * nominalvoltage) - ((Math.sqrt(3) * nominalvoltage) * 0.08);
			var ULLMAX = (Math.sqrt(3) * nominalvoltage) + ((Math.sqrt(3) * nominalvoltage) * 0.08);
		}else if(iecclass === 2){
			var ULNMIN = nominalvoltage - (nominalvoltage * 0.1);
			var ULNMAX = nominalvoltage + (nominalvoltage * 0.1);
			var ULLMIN = (Math.sqrt(3) * nominalvoltage) - ((Math.sqrt(3) * nominalvoltage) * 0.1);
			var ULLMAX = (Math.sqrt(3) * nominalvoltage) + ((Math.sqrt(3) * nominalvoltage) * 0.1);
		}else if(iecclass === 3){
			var ULNMIN = nominalvoltage - (nominalvoltage * 0.15);
			var ULNMAX = nominalvoltage + (nominalvoltage * 0.1);
			var ULLMIN = (Math.sqrt(3) * nominalvoltage) - ((Math.sqrt(3) * nominalvoltage) * 0.15);
			var ULLMAX = (Math.sqrt(3) * nominalvoltage) + ((Math.sqrt(3) * nominalvoltage) * 0.1);
		}

        //determine frequency limits
        var nominalfreq = data['_NOMINAL_F'][0];

        if (nominalfreq === 0) {
            var freqavg = data['_FREQ_AVG'][0];
            var nominalfreq = Math.round(freqavg / 10) * 10;
        }
        var FREQMIN = nominalfreq - (nominalfreq * 0.02);
        var FREQMAX = nominalfreq + (nominalfreq * 0.02);

        //check voltage minimum
        if (data['_ULN_AVG'][0][0] < ULNMIN || data['_ULN_AVG'][0][1] < ULNMIN || data['_ULN_AVG'][0][2] < ULNMIN) {
            failure = true;
        }
        if (data['_ULL_AVG'][0][0] < ULLMIN || data['_ULL_AVG'][0][1] < ULLMIN || data['_ULL_AVG'][0][2] < ULLMIN) {
            failure = true;
        }
        
        //check voltage maximum
        if (data['_ULN_AVG'][0][0] > ULNMAX || data['_ULN_AVG'][0][1] > ULNMAX || data['_ULN_AVG'][0][2] > ULNMAX) {
            failure = true;
        }
        if (data['_ULL_AVG'][0][0] > ULLMAX || data['_ULL_AVG'][0][1] > ULLMAX || data['_ULL_AVG'][0][2] > ULLMAX) {
            failure = true;
        }
        
        //check frequency
        if (data['_FREQ_AVG'][0] < FREQMIN || data['_FREQ_AVG'][0] > FREQMAX) {
            failure = true;
        }

        //check THD-U
		if(iecclass === 1){
			if (data['_THD_ULN_AVG'][0][0] > 5 || data['_THD_ULN_AVG'][0][1] > 5 || data['_THD_ULN_AVG'][0][2] > 5) {
				failure = true;
			}
		}else if(iecclass === 2){
			if (data['_THD_ULN_AVG'][0][0] > 8 || data['_THD_ULN_AVG'][0][1] > 8 || data['_THD_ULN_AVG'][0][2] > 8) {
				failure = true;
			}
		}else if(iecclass === 3){
			if (data['_THD_ULN_AVG'][0][0] > 10 || data['_THD_ULN_AVG'][0][1] > 10 || data['_THD_ULN_AVG'][0][2] > 10) {
				failure = true;
			}
		}
		
        

        //check asym
		if(iecclass === 1){
			if (data['_U_SYM_AVG'][0] > 2) {
				failure = true;
			}
		}else if(iecclass === 2){
			if (data['_U_SYM_AVG'][0] > 2) {
				failure = true;
			}
		}else if(iecclass === 3){
			if (data['_U_SYM_AVG'][0] > 3) {
				failure = true;
			}
		}
        

        //check harmonics
		if(iecclass === 1){
			var c2limits = [100, 2, 3, 1.0, 3, 0.5, 3, 0.5, 1.5, 0.5, 3.0, 0.46, 3.0, 0.43, 0.30, 0.40, 2, 0.39, 1.76, 0.38, 0.20, 0.36, 1.41, 0.35, 1.27, 0.35, 0.20, 0.34, 1.06, 0.33, 0.97, 0.33, 0.20, 0.32, 0.83, 0.32, 0.77, 0.32, 0.20, 0.31, 0.67, 0.31, 0.63, 0.31, 0.20, 0.30, 0.55, 0.30, 0.52, 0.30];
		}else if(iecclass === 2){
			var c2limits = [100, 2, 5, 1.0, 6, 0.5, 5, 0.5, 1.5, 0.5, 3.5, 0.46, 3.0, 0.43, 0.40, 0.41, 2, 0.39, 1.76, 0.38, 0.20, 0.36, 1.41, 0.20, 1.27, 0.35, 0.20, 0.34, 1.06, 0.20, 0.97, 0.33, 0.20, 0.32, 0.83, 0.20, 0.77, 0.32, 0.20, 0.31, 0.67, 0.31, 0.63, 0.31, 0.20, 0.30, 0.55, 0.30, 0.52, 0.30];
		}else if(iecclass === 3){
			var c2limits = [100, 3, 6, 1.5, 8, 1.0, 7, 1.0, 2.5, 1.0, 5.0, 1.00, 4.5, 1.00, 2.00, 1.00, 4, 1.00, 3.53, 1.00, 1.75, 1.00, 2.83, 1.00, 2.56, 1.00, 1.00, 1.00, 2.14, 1.00, 1.97, 1.00, 1.00, 1.00, 1.69, 1.00, 1.57, 1.00, 1.00, 1.00, 1.37, 1.00, 1.28, 1.00, 1.00, 1.00, 1.13, 1.00, 1.06, 1.00];
		}
						
        for (var i = 1; i < 50; i++) {
            var value1 = (100 * data["_FFT_UL1"][0][i]) / data["_FFT_UL1"][0][0];
            var value2 = (100 * data["_FFT_UL2"][0][i]) / data["_FFT_UL2"][0][0];
            var value3 = (100 * data["_FFT_UL3"][0][i]) / data["_FFT_UL3"][0][0];
            if (value1 > c2limits[i]) { failure = true; };
            if (value2 > c2limits[i]) { failure = true; };
            if (value3 > c2limits[i]) { failure = true; };
        }

        if (failure) {
            $("#iecind").html("<img src='../../../img/fail.png' alt='failed' title='" + tl('home.iecred') + "' style='width: 30px; height: 30px;'>");
        } else {
            $("#iecind").html("<img src='../../../img/pass.png' alt='passed' title='" + tl('home.iecgreen') + "' style='width: 30px; height: 30px;'>");
        }

        //last report status IEC61000-2-4
        if (data['_GBL_IEC_LASTSTATUS'][0] === 3) {
            $("#iecrep").html("<img src='../../../img/fail.png' alt='failed' title='" + tl('home.iecred') + "' style='width: 30px; height: 30px;'>");
        } else if (data['_GBL_IEC_LASTSTATUS'][0] === 2) {
            $("#iecrep").html("<img src='../../../img/warn.png' alt='warn' title='" + tl('home.iecorange') + "' style='width: 30px; height: 30px;'>");
        } else if (data['_GBL_IEC_LASTSTATUS'][0] === 1) {
            $("#iecrep").html("<img src='../../../img/pass.png' alt='pass' title='" + tl('home.iecgreen') + "'  style='width: 30px; height: 30px;'>");
        } else {
            $("#iecrep").html("<img src='../../../img/icon_help_bk.png' alt='pass' title='" + tl('home.iecna') + "' style='width: 30px; height: 30px;'>");
        }
    });
}

function getieeereport() {
    //create url with required variable
    var url = url = "../.../.../../../json.do?_GBL_IEEE519_LASTSTATUS,";

    //request data
    $.getJSON(url, function (data) {
        //last report status IEEE519
        // 0 = n/a, 1 = green, 2 = orange, 3 = red
        if(data['_GBL_IEEE519_LASTSTATUS'][0] === 3){
            $("#ieeerep").html("<img src='../../../img/fail.png' alt='failed' title='" + tl('home.ieeered') + "' style='width: 30px; height: 30px;'>");  
        }else if(data['_GBL_IEEE519_LASTSTATUS'][0] === 2){
            $("#ieeerep").html("<img src='../../../img/warn.png' alt='warn' title='" + tl('home.ieeeorange') + "' style='width: 30px; height: 30px;'>");  
        }else if(data['_GBL_IEEE519_LASTSTATUS'][0] === 1){
            $("#ieeerep").html("<img src='../../../img/pass.png' alt='pass' title='" + tl('home.ieeegreen') + "'  style='width: 30px; height: 30px;'>");  
        }else{
            $("#ieeerep").html("<img src='../../../img/icon_help_bk.png' alt='pass' title='" + tl('home.ieeena') + "' style='width: 30px; height: 30px;'>");  
        }
    });
}


function getenindicationandreport() {

    console.log('determine en50160');

    var failure = false;

    //create url with required variables
    var url = url = "../.../.../../../json.do?";
    url += "_ULN_AVG[0..2],_ULL_AVG[0..2],_THD_ULN_AVG[0..2],_FREQ_AVG,_U_SYM_AVG";
    url += ",_FFT_UL1[0..25],_FFT_UL2[0..25],_FFT_UL3[0..25],_FLI_LONG_TERM[0..2]";
    url += ",_NOMINAL_U[0],_NOMINAL_F,_GBL_50160_LASTSTATUS,";

    //request data
    $.getJSON(url, function (data) {

        //determine voltage limits
        var nominalvoltage = data['_NOMINAL_U'][0][0];
        // nominalvoltage on UMG512 is always set to L/N
        var ULNMIN = nominalvoltage - (nominalvoltage * 0.1);
        var ULNMAX = nominalvoltage + (nominalvoltage * 0.1);
        var ULLMIN = (Math.sqrt(3) * nominalvoltage) - ((Math.sqrt(3) * nominalvoltage) * 0.1);
        var ULLMAX = (Math.sqrt(3) * nominalvoltage) + ((Math.sqrt(3) * nominalvoltage) * 0.1);

        //determine frequency limits
        var nominalfreq = data['_NOMINAL_F'][0];

        if (nominalfreq === 0) {
            var freqavg = data['_FREQ_AVG'][0];
            var nominalfreq = Math.round(freqavg / 10) * 10;
        }
        var FREQMIN = nominalfreq - (nominalfreq * 0.01);
        var FREQMAX = nominalfreq + (nominalfreq * 0.01);

        //check voltage minimum
        if (data['_ULN_AVG'][0][0] < ULNMIN || data['_ULN_AVG'][0][1] < ULNMIN || data['_ULN_AVG'][0][2] < ULNMIN) {
            failure = true;
        }
        if (data['_ULL_AVG'][0][0] < ULLMIN || data['_ULL_AVG'][0][1] < ULLMIN || data['_ULL_AVG'][0][2] < ULLMIN) {
            failure = true;
        }

        //check voltage maximum
        if (data['_ULN_AVG'][0][0] > ULNMAX || data['_ULN_AVG'][0][1] > ULNMAX || data['_ULN_AVG'][0][2] > ULNMAX) {
            failure = true;
        }
        if (data['_ULL_AVG'][0][0] > ULLMAX || data['_ULL_AVG'][0][1] > ULLMAX || data['_ULL_AVG'][0][2] > ULLMAX) {
            failure = true;
        }

        //check frequency
        if (data['_FREQ_AVG'][0] < FREQMIN || data['_FREQ_AVG'][0] > FREQMAX) {
            failure = true;
        }

        //check THD-U
        if (data['_THD_ULN_AVG'][0][0] > 8 || data['_THD_ULN_AVG'][0][1] > 8 || data['_THD_ULN_AVG'][0][2] > 8) {
            failure = true;
        }

        //check asym
        if (data['_U_SYM_AVG'][0] > 2) {
            failure = true;
        }

        //check Long-term-flicker
        if (data['_FLI_LONG_TERM'][0][0] > 1 || data['_FLI_LONG_TERM'][0][1] > 1 || data['_FLI_LONG_TERM'][0][2] > 1) {
            failure = true;
        }

        //check harmonics
        var c2limits = [100, 2, 5, 1, 6, 0.5, 5, 0.5, 1.5, 0.5, 3.5, 0.5, 3.0, 0.5, 0.5, 0.5, 2, 0.5, 1.5, 0.5, 0.5, 0.5, 1.5, 0.5, 1.5];

        for (var i = 1; i < 25; i++) {
            var value1 = (100 * data["_FFT_UL1"][0][i]) / data["_FFT_UL1"][0][0];
            var value2 = (100 * data["_FFT_UL2"][0][i]) / data["_FFT_UL2"][0][0];
            var value3 = (100 * data["_FFT_UL3"][0][i]) / data["_FFT_UL3"][0][0];
            if (value1 > c2limits[i]) { failure = true; };
            if (value2 > c2limits[i]) { failure = true; };
            if (value3 > c2limits[i]) { failure = true; };
        }

        if (failure) {
            $("#enind").html("<img src='../../../img/fail.png' alt='failed' title='" + tl('home.enred') + "' style='width: 30px; height: 30px;'>");
        } else {
            $("#enind").html("<img src='../../../img/pass.png' alt='pass' title='" + tl('home.engreen') + "'  style='width: 30px; height: 30px;'>");
        }

        //last report status EN50160
        if (data['_GBL_50160_LASTSTATUS'][0] === 3) {
            $("#enrep").html("<img src='../../../img/fail.png' alt='failed' title='" + tl('home.enred') + "' style='width: 30px; height: 30px;'>");
        } else if (data['_GBL_50160_LASTSTATUS'][0] === 2) {
            $("#enrep").html("<img src='../../../img/warn.png' alt='warn' title='" + tl('home.enorange') + "' style='width: 30px; height: 30px;'>");
        } else if (data['_GBL_50160_LASTSTATUS'][0] === 1) {
            $("#enrep").html("<img src='../../../img/pass.png' alt='pass' title='" + tl('home.engreen') + "'  style='width: 30px; height: 30px;'>");
        } else {
            $("#enrep").html("<img src='../../../img/icon_help_bk.png' alt='pass' title='" + tl('home.enna') + "' style='width: 30px; height: 30px;'>");
        }
    });
}
