/* JAVASCRIPT FOR EVENT PAGE JANITZA UMG512
 * 
 * Version:  2.0
 * Date:     18-11-2019
 
EVENT REASONS:
HEX 64 bit        - HEX_LO   - HEX_HI
0x0000000000000001- 00000001 - 00000000  - Over Voltage L/N
0x0000000000000010- 00000010 - 00000000  - Under Voltage L/N
0x0000000000000100- 00000100 - 00000000  - Voltage Outage L/N
0x0000000000001000- 00001000 - 00000000  - Over Current

0x0000000000100000- 00100000 - 00000000  - Over Voltage L/L
0x0000000001000000- 01000000 - 00000000  - Under Voltage L/L
0x0000000010000000- 10000000 - 00000000  - Voltage Outage L/L

0x0000010000000000- 00000000 - 00000100  - Over Frequency
0x0000100000000000- 00000000 - 00001000  - Under Frequency
0x0001000000000000- 00000000 - 00010000  - DT Frequency Event
0x0010000000000000- 00000000 - 00100000  - Rapid Voltage Change L/N
0x0100000000000000- 00000000 - 01000000  - Rapid Voltage Change L/L
0x1000000000000000- 00000000 - 10000000  - Rapid Voltage Change Multi Phase

*/

var locked = false;
var SelectedEventElement = null;
var eventdata;
var hwwdata = null;
var firstevent = null;
var realgraphdata = {};
var graphdata = {};
var graphcolor = ['#FF0000', '#0000FF', '#FFFF00', '#FFFFF0', '#FFFFFF'];
// ChannelColor = [Voltage L1,L2,L3,L4, Current L1,L2,L3,L4,x,x,x,x,x,x,x,x, Voltage L1-L2,L2-L3,L3-L1]
var channelcolor = ['#FF0000', '#0000FF', '#FFF000', '#229954', '#8E44AD', '#DC7633', '#85C1E9', '#95A5A6', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#ffffff', '#cc9900', '#00b050', '#000000'];
var checkboxIds = ['#colorboxUL1', '#colorboxUL2', '#colorboxUL3', '#colorboxUL4', '#colorboxIL1', '#colorboxIL2', '#colorboxIL3', '#colorboxIL4', '', '', '', '', '', '', '', '', '#colorboxULL1', '#colorboxULL2', '#colorboxULL3'];
var graphs = null;
var graphcnt = 0;

function initevents() {
    eventsinit();

    $('input:checkbox').change(
        function () {

            if (locked) {
                alert(tl("event.wait"));
                if ($(this).is(':checked')) {
                    $(this).prop('checked', false);
                } else {
                    $(this).prop('checked', true);
                }
            } else {

                console.log("int event ; GraphCnt : " + graphcnt);
                if (graphcnt == 0) {
                    $("#eventgraph").empty();
                    $("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
                    $("#loader").hide();
                    locked = false;
                    return;

                }


                $("#loader").show();
                locked = true;
                if ($(this).is(':checked')) {
                    AddGraph($(this).val());
                    $(checkboxIds[$(this).val()]).css("visibility", "visible");
                } else {
                    UpdateRealGraph();
                    $(checkboxIds[$(this).val()]).css("visibility", "hidden");
                }
            }
        }
    );
}

////////////////////////////////////////////
// EVENTSINIT: start javascript functions
////////////////////////////////////////////
function eventsinit() {
    $.getJSON("../../../../lib/events/getevt.html", function (data) {

        var aantalevents = data['events'].length;
        eventdata = data['events'];

        var fse = true; //first selected event

        var count = 0;
        for (var i = 0; i < aantalevents; i++) {

            var evtdata = convertReason(data['events'][i][6], data['events'][i][7]);
            var listitem = "<div style=\"float:right;color:#000000;padding:3px\">" + (parseInt(count) + 1) + "</div><b style=\"cursor:pointer\">" + evtdata[1] + " - " + evtdata[2] + "</b><br>";

            var el = document.createElement("div");
            el.className = "eventitem" + ((count % 2 == 0) ? "even" : "");
            el.setAttribute("name", i);

            listitem += toDeviceTimeString(data['events'][i][0]) + " " + readableSeconds(data['events'][i][1] - data['events'][i][0]);
            el.innerHTML = listitem;
            el.onclick = eventlist_click;

            //fix to hide "future" events
            var dto = new Date();
            dto.setFullYear(dto.getFullYear() + 1);

            if ((dto.getTime() / 1000) > data['events'][i][0] && evtdata[1] != -1) {

                $("#list").append(el);
                count++;
                if (fse) {

                    fse = false;

                    // Fake Event in order to populate Table Info on startup
                    var fakeevent = {'target': el};
                    firstevent = fakeevent;

                }
            }
        }

        //Fake last item
        var listitem = tl("event.endmessage");
        var el = document.createElement("div");
        el.className = "eventitem" + ((count % 2 == 0) ? "even" : "");
        el.setAttribute("name", i);
        el.innerHTML = listitem;
        $("#list").append(el);

        hwwinit();

    });
}

function AddGraph(channel) {

    channel = parseInt(channel);
    console.log("Addgraph with channel: " + channel);
    console.log("GraphCnt : " + graphcnt);


    //check if it's allready available
    var art = false;
    for (var x in graphdata) {
        if (graphdata[x].channel === parseInt(channel)) {
            art = true;
        }
    }

    //if it is not there go get it
    if (art === false) {
        console.log("Graph is not available yet");
        //loop through availabe graphs
        $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[0] + "&_val_nr=" + channel, function (data) {
            //add graphdata to the array
            graphdata[graphcnt] = data;
            //add the label to the array
            graphdata[graphcnt]['label'] = getChannelName(channel);
            graphdata[graphcnt]['channel'] = channel;
            //check if voltage or current

            if (channel === 4 || channel === 5 || channel === 6 || channel === 7) {
                graphdata[graphcnt]['yaxis'] = 2;
            }

            graphcnt++;
            realgraphdata = graphdata;

            UpdateRealGraph();

        });
    } else {
        //update realgraphdata
        UpdateRealGraph();
    }
}

function UpdateRealGraph() {
    console.log("Update real graphs");
    realgraphdata = {};
    var gdc = 0;
    for (var x in graphdata) {

        if ($('#V' + graphdata[x].channel).is(':checked')) {
            graphcolor[gdc] = channelcolor[graphdata[x].channel];
            realgraphdata[gdc] = graphdata[x];
            gdc++;
        }

    }

    showhww();
}

////////////////////////////////////////////
// HWWINIT: start javascript functions
////////////////////////////////////////////
function hwwinit() {
    $.getJSON("../../../../lib/events/hww.html", function (data) {
        hwwdata = data['hww'];
        eventlist_click(firstevent);
    });
}

////////////////////////////////////////////
// READABLESECONDS: convert duration to sec
////////////////////////////////////////////
function readableSeconds(s) {
    if (s > 60 * 60) {
        var h = Math.floor(s / (60 * 60));
        var m = Math.floor(s / 60) - h * 60;
        var sec = Math.runde((s - (h * 60 * 60 + m * 60)), 2);
        return h + "h " + m + "m " + sec + "s";
    }
    if (s > 60) {
        var m = Math.floor(s / (60));
        var sec = Math.runde((s - m * 60), 2);
        return m + "m " + sec + "s";
    }

    return Math.runde(s, 2) + "s";
}

////////////////////////////////////////////
// CONVERTREASON: convert event reason to unit, type and phase
////////////////////////////////////////////

const getEventData = (evtUnit, i18nKey, hexPhase, unit) =>
    [evtUnit, tl(i18nKey), PHASECODE_TO_PHASE.get(hexPhase), HexToCode(hexPhase, unit ? unit : 1)];

const convertReason = (reasonLo, reasonHi) => {
    if (reasonHi === 0 && reasonLo === 0) {
        return ["-", -1, -1, -1];
    }

    if (!reasonHi) {
        if (reasonLo >= 268435456) {
            const phaseCode = parseInt(reasonLo / 268435456 + 100);
            return getEventData("V", "events.UOUTLL", phaseCode);
        } else if (reasonLo >= 16777216) {
            const phaseCode = parseInt(reasonLo / 16777216 + 100);
            return getEventData("V", "events.UMINLL", phaseCode);
        } else if (reasonLo >= 1048576) {
            const phaseCode = parseInt(reasonLo / 1048576 + 100);
            return getEventData("V", "events.UMAXLL", phaseCode);
        } else if (reasonLo >= 4096) {
            const phaseCode = parseInt(reasonLo / 4096);
            return getEventData("A", "events.IMAX", phaseCode, 2);
        } else if (reasonLo >= 256) {
            const phaseCode = parseInt(reasonLo / 256);
            return getEventData("V", "events.UOUTLN", phaseCode);
        } else if (reasonLo >= 16) {
            const phaseCode = parseInt(reasonLo / 16);
            return getEventData("V", "events.UMINLN", phaseCode);
        } else {
            const phaseCode = parseInt(reasonLo);
            return getEventData("V", "events.UMAXLN", phaseCode);
        }
    } else {
        if (reasonHi >= 16777216) {
            const phaseCode = parseInt(reasonHi / 16777216 + 100);
            return getEventData("V", "events.URVCLL", phaseCode);
        } else if (reasonHi >= 1048576) {
            const phaseCode = parseInt(reasonHi / 1048576);
            return getEventData("V", "events.URVCLN", phaseCode);
        } else if (reasonHi >= 65536) {
            const phaseCode = parseInt(reasonHi / 65536); // + 100?
            return getEventData("Hz", "events.FDELTA", phaseCode);
        } else if (reasonHi >= 4096) {
            const phaseCode = parseInt(reasonHi / 4096); // + 100?
            return getEventData("Hz", "events.FMIN", phaseCode);
        } else if (reasonHi >= 256) {
            const phaseCode = parseInt(reasonHi / 256); // + 100?
            return getEventData("Hz", "events.FMAX", phaseCode);
        } else {
            console.log(`ERROR: cannot map reasonHi ${reasonHi} and reasonLo ${reasonLo} to event`);
            return ["-", -1, -1, -1];
        }
    }
};

////////////////////////////////////////////
// HEXTOPHASE: convert hex to phase
////////////////////////////////////////////
const PHASECODE_TO_PHASE = new Map();
PHASECODE_TO_PHASE.set(1, "L1");
PHASECODE_TO_PHASE.set(2, "L2");
PHASECODE_TO_PHASE.set(4, "L3");
PHASECODE_TO_PHASE.set(8, "L4");
PHASECODE_TO_PHASE.set(101, "L1-L2");
PHASECODE_TO_PHASE.set(102, "L2-L3");
PHASECODE_TO_PHASE.set(104, "L3-L1");

////////////////////////////////////////////
// HEXTOPHASE: convert hex to graph
////////////////////////////////////////////
function HexToCode(phase, unit) {
    if (unit == 1) { //voltage
        switch (phase) {
            case 1:
                return 0
                break;
            case 2:
                return 1
                break;
            case 4:
                return 2
                break;
            case 8:
                return 3
                break;
            case 101:
                return 16
                break;
            case 102:
                return 17
                break;
            case 104:
                return 18
                break;
        }
    } else {
        switch (phase) {
            case 1:
                return 4
                break;
            case 2:
                return 5
                break;
            case 4:
                return 6
                break;
            case 8:
                return 7
                break;
        }
    }
}

function PadZeros(i, len) {
    var s = i.toString();
    var erg = "";
    for (var d = 0; d < len - s.length; d++)
        erg += "0";
    return erg + s;
}


function eventlist_click(evt) {
    clearColorboxes();
    if (locked) {
        alert(tl("event.wait"));
    } else {
        locked = true;
        $("#eventgraph").empty();
        $("#overviewLegend").empty();
        $("#loader").show();

        evt = (evt) ? evt : ((window.event) ? window.event : "");
        var elem = evt.target;
        var iHWW = parseInt(elem.getAttribute("Name"));
        if (isNaN(iHWW)) {
            elem = evt.target.parentNode;
            iHWW = parseInt(elem.getAttribute("Name"));
        }

        if (SelectedEventElement) {
            removeStyleClass(SelectedEventElement, "eventitem_selected");
        }

        var iHWW = parseInt(elem.getAttribute("name"));
        var evtdata = convertReason(eventdata[iHWW][6], eventdata[iHWW][7]);

        evt_time = eventdata[iHWW][0];
        fillspan("info_starttime", toDeviceTimeString(eventdata[iHWW][0]));
        fillspan("info_duration", readableSeconds(eventdata[iHWW][1] - eventdata[iHWW][0]));
        fillspan("info_phase", "L" + evtdata[2]);
        fillspan("info_bound", String(eventdata[iHWW][2]).replace(/\./, getDecimalPoint()) + " " + evtdata[0]);
        fillspan("info_maxval", String(eventdata[iHWW][3]).replace(/\./, getDecimalPoint()) + " " + evtdata[0]);
        fillspan("info_minval", String(eventdata[iHWW][4]).replace(/\./, getDecimalPoint()) + " " + evtdata[0]);
        fillspan("info_avg", String(eventdata[iHWW][5]).replace(/\./, getDecimalPoint()) + " " + evtdata[0]);
        fillspan("info_reason", evtdata[1]);

        //Grafieklijnen (HWW's) zoeken bij event
        graphs = FindHwwForEvent(eventdata[iHWW]);
        graphdata = {};
        GetGraphData(evtdata[3], evt_time);

        addStyleClass(elem, "eventitem_selected");
        SelectedEventElement = elem;
    }
}

function fillspan(id, txt) {
    var obj = document.getElementById(id);
    if (obj)
        obj.innerHTML = txt;
}

function FindHwwForEvent(Event) {
    var list = [];

    for (var i in hwwdata) {
        if (i in Array.prototype) {
            continue;
        }

        if (Event[0] < hwwdata[i][1] && Event[0] > hwwdata[i][0]) {
            list.push(parseInt(i));
        }
    }
    return list;
}

///////////////////////////////////////
// Loops through the available graphs for the selected event and downloads the data
///////////////////////////////////////
function GetGraphData(channel, starttime) {

    $('#V0').prop("checked", false);
    $('#V1').prop("checked", false);
    $('#V2').prop("checked", false);
    $('#V3').prop("checked", false);
    $('#V4').prop("checked", false);
    $('#V5').prop("checked", false);
    $('#V6').prop("checked", false);
    $('#V7').prop("checked", false);
    $('#V16').prop("checked", false);
    $('#V17').prop("checked", false);
    $('#V18').prop("checked", false);

    $('#V' + channel).prop("checked", true);

    var graphcount = graphs.length;

    if (graphcount > 1) {
        graphcount = 1;
    }

    if (graphcount === 0) {
        $("#eventgraph").empty();
        $("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
        $("#loader").hide();
        graphcnt = 0;
        locked = false;
    } else {

        $(checkboxIds[channel]).css("visibility", "visible");
        $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[0] + "&_val_nr=" + channel + "&_hww_start=" + starttime, function (data) {
            //add graphdata to the array
            graphdata[graphcnt] = data;
            //add the label to the array
            graphdata[graphcnt]['label'] = getChannelName(channel);
            graphdata[graphcnt]['channel'] = channel;
            //check if voltage or current

            if (channel === 4 || channel === 5 || channel === 6 || channel === 7) {
                graphdata[graphcnt]['yaxis'] = 2;
            }

            console.log("Initgraph with channel: " + channel);

            graphcnt = 1;
            realgraphdata = graphdata;

            UpdateRealGraph();
            // showhww();

        });

    }
}

function getChannelName(i) {
    switch (i) {
        case 0:
            return tl("menu.voltage") + " " + tl("L1");
        case 4:
            return tl("menu.current") + " " + tl("L1");
        case 1:
            return tl("menu.voltage") + " " + tl("L2");
        case 5:
            return tl("menu.current") + " " + tl("L2");
        case 2:
            return tl("menu.voltage") + " " + tl("L3");
        case 6:
            return tl("menu.current") + " " + tl("L3");
        case 3:
            return tl("menu.voltage") + " " + tl("L4");
        case 7:
            return tl("menu.current") + " " + tl("L4");
        default:
            return i;
    }
}


function showhww() {

    var i = 0;

    $("#loader").hide();
    locked = false;
    var container = document.getElementById('eventgraph');
    var d1 = [];
    var i, graph;

    var options = {
        linewidth: 1,
        xaxis: {
            tickFormatter: function (val, axis) {
                return dateFormat(getFakedLocalDeviceTime(val), "HH:MM:ss");
            },
            autoscale: false
        },
        yaxis: {
            tickFormatter: function (val, axis) {
                return val + "V";
            },
            autoscale: true
        },
        y2axis: {
            tickFormatter: function (val, axis) {
                return val + "A";
            },
            autoscale: true
        },
        grid: {
            minorVerticalLines: true
        },
        mouse: {
            track: true,
            relative: true,
            sensibility: 10,
            radius: 5,
            trackFormatter: function (obj) {

                var time = getFakedLocalDeviceTime(obj.nearest.x);
                var val = obj.nearest.series.label;
                var unit = "";
                if (obj.series.yaxis.n === 1) {
                    unit = "V"
                } else {
                    unit = "A"
                }

                return val + ', X: ' + dateFormat(time, "HH:MM:ss.l") + ', Y: ' + obj.y + unit;
            }
        },
        selection: {
            mode: 'x',
            fps: 30
        }, legend: {
            position: 'se'
        }
    };


    /// Draw graph with default options, overwriting with passed options
    function drawGraph(opts) {

        var data = realgraphdata;

        // Clone the options, so the 'options' variable always keeps intact.
        var o = Flotr._.extend(Flotr._.clone(options), opts || {});

        o.colors = graphcolor;

        // Return a new graph.
        return Flotr.draw(container, data, o);
    }

    // Actually draw the graph.
    drawGraph();

    // Hook into the 'flotr:select' event.
    Flotr.EventAdapter.observe(container, 'flotr:select', function (area) {

        // Draw graph with new area
        graph = drawGraph({
            xaxis: {
                min: area.x1,
                max: area.x2,
                minorTickFreq: 4,
                mode: "time",
                timeMode: "local",
                timeUnit: 'second'
            },
            yaxis: {
                min: area.y1,
                max: area.y2,
                tickFormatter: function (val, axis) {
                    return val + "V";
                },
                autoscale: true
            }
        });
    });

    // When graph is clicked, draw the graph with default area.
    Flotr.EventAdapter.observe(container, 'flotr:click', function () {
        drawGraph();
    });

}

function addStyleClass(elem, cssClassName) {

    if (elem.className.indexOf(cssClassName) < 0)
        elem.className += " " + cssClassName;
}


function removeStyleClass(elem, cssClassName) {
    elem.className = elem.className.replace(cssClassName, "");
}

setTimeout(function () {
    $('#colorboxUL1').css("background-color", channelcolor[0]);
    $('#colorboxUL2').css("background-color", channelcolor[1]);
    $('#colorboxUL3').css("background-color", channelcolor[2]);
    $('#colorboxUL4').css("background-color", channelcolor[3]);
    $('#colorboxIL1').css("background-color", channelcolor[4]);
    $('#colorboxIL2').css("background-color", channelcolor[5]);
    $('#colorboxIL3').css("background-color", channelcolor[6]);
    $('#colorboxIL4').css("background-color", channelcolor[7]);
    $('#colorboxULL1').css("background-color", channelcolor[16]);
    $('#colorboxULL2').css("background-color", channelcolor[17]);
    $('#colorboxULL3').css("background-color", channelcolor[18]);
}, 200);

clearColorboxes = () => {
    $('#colorboxUL1').css('visibility', 'hidden');
    $('#colorboxUL2').css('visibility', 'hidden');
    $('#colorboxUL3').css('visibility', 'hidden');
    $('#colorboxUL4').css('visibility', 'hidden');
    $('#colorboxIL1').css('visibility', 'hidden');
    $('#colorboxIL2').css('visibility', 'hidden');
    $('#colorboxIL3').css('visibility', 'hidden');
    $('#colorboxIL4').css('visibility', 'hidden');
    $('#colorboxULL1').css('visibility', 'hidden');
    $('#colorboxULL2').css('visibility', 'hidden');
    $('#colorboxULL3').css('visibility', 'hidden');
}

// Exporting function for unit tests
module.exports = {
    convertReason
};