/* JAVASCRIPT FOR EVENT PAGE JANITZA UMG512
 * 
 * Version:  1.1
 * Date:     06-06-2016   
 */

setTimeout(function () {
    eventsinit();
}, 200);

var locked = false;
var SelectedEventElement = null;
var eventdata;
var hwwdata = null;
var firstevent = null;
var realgraphdata = {};
var graphdata = {};
var graphs = null;

////////////////////////////////////////////
// EVENTSINIT: start javascript functions
////////////////////////////////////////////
function eventsinit() {

    $.getJSON("../../../../lib/events/getevt.html", function (data) {

        var aantalevents = data['events'].length;
        eventdata = data['events'];

        var fse = true; //first selected event

        for (var i = 0; i < aantalevents; i++) {

            var evtdata = convertreason(data['events'][i][6]);
            var listitem = "<div style=\"float:right;color:#000000;padding:3px\">" + (parseInt(i) + 1) + "</div><b style=\"cursor:pointer\">" + tl("events.item") + " " + evtdata[1] + " " + evtdata[2] + "</b><br>";

            var el = document.createElement("div");
            el.className = "eventitem" + ((i % 2 == 0) ? "even" : "");
            el.setAttribute("name", i);

            listitem += timestrActual(data['events'][i][0]) + " " + readableSeconds(data['events'][i][1] - data['events'][i][0]);
            el.innerHTML = listitem;
            el.onclick = eventlist_click;

            //fix to hide "future" events
            var dto = new Date();
            dto.setFullYear(dto.getFullYear() + 1);
            if ((dto.getTime() / 1000) > data['events'][i][0]) {
                $("#list").append(el);

                if (fse) {

                    fse = false;

                    // Fake Event in order to populate Table Info on startup
                    var fakeevent = {'target': el};
                    firstevent = fakeevent;
                    

                    
                }

            }



            /*
             var tablerow = "<tr>" +
             "<td>"+evtdata[1]+"</td>" +
             "<td>"+evtdata[2]+"</td>" +
             "<td>"+ timestrActual(data['events'][i][0]) +"</td>" +
             "<td>"+ readableSeconds(data['events'][i][1] - data['events'][i][0]) + "</td>" +
             "<td>" + data['events'][i][3].toString().replace(/\./, getDecimalPoint()) + " " + evtdata[0]+"</td>" +
             "<td>" + data['events'][i][4].toString().replace(/\./, getDecimalPoint()) + " " + evtdata[0]+"</td>" +
             "<td>" + data['events'][i][5].toString().replace(/\./, getDecimalPoint()) + " " + evtdata[0]+"</td>" +
             "<td>" + data['events'][i][2].toString().replace(/\./, getDecimalPoint()) + " " + evtdata[0]+"</td>" +
             "</tr>";
             */


        }

        hwwinit();

    });
}

////////////////////////////////////////////
// HWWINIT: start javascript functions
////////////////////////////////////////////
function hwwinit() {

    $.getJSON("../../../../lib/events/hww.html", function (data) {

        hwwdata = data['hww'];
        eventlist_click(firstevent);
    });
}

////////////////////////////////////////////
// TIMESTRACTUAL: convert timestring to date/time
////////////////////////////////////////////
function timestrActual(i) {
    var DAYLENGTH = 24 * 60 * 60 * 1000; //24h in ms
    var past = new Date(i * 1000);
    var now = new Date();
    var tomorrowMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate() + 1);
    var todayMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate());
    var yesterdayMidnight = new Date(now.getFullYear(), now.getMonth(), now.getDate() - 1);

    //Today?
    if (past >= todayMidnight && past < tomorrowMidnight) {
        return tl("info.time.today") + ", " + PadZeros(past.getHours(), 2) + ":" + PadZeros(past.getMinutes(), 2) + ":" + PadZeros(past.getSeconds(), 2);
    }
    //Yesterday?
    if (past >= yesterdayMidnight && past < todayMidnight) {
        return tl("info.time.yesterday") + ", " + PadZeros(past.getHours(), 2) + ":" + PadZeros(past.getMinutes(), 2) + ":" + PadZeros(past.getSeconds(), 2);
    }
    return new Date(i * 1000).toLocaleString();
}


////////////////////////////////////////////
// READABLESECONDS: convert duration to sec
////////////////////////////////////////////
function readableSeconds(s)
{
    if (s > 60 * 60) {
        var h = Math.floor(s / (60 * 60));
        var m = Math.floor(s / 60) - h * 60;
        var sec = Math.runde((s - (h * 60 * 60 + m * 60)), 2);
        return  h + "h " + m + "m " + sec + "s";
    }
    if (s > 60) {
        var m = Math.floor(s / (60));
        var sec = Math.runde((s - m * 60), 2);
        return m + "m " + sec + "s";
    }

    return Math.runde(s, 2) + "s";
}

////////////////////////////////////////////
// CONVERTREASON: convert event reason to unit, type and phase
////////////////////////////////////////////
function convertreason(reason) {

    var voltage = false;
    var evtdata = new Array(4);

    //console.log("reason: " + reason);       
    //console.log("reasonhex: " + reason.toString(16));

    var phasecode = parseInt(reason.toString(16));
    var eventcode = parseInt(reason.toString(16));
    console.log("eventcode: " + eventcode);

    //Overvoltage LN
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(1);
        evtdata[2] = HexToPhase(eventcode);
        voltage = true;
        return evtdata;
    }

    eventcode = eventcode / 10;


    //Undervoltage LN
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(2);
        evtdata[2] = HexToPhase(eventcode);
        voltage = true;
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Voltage disruption LN
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(4);
        evtdata[2] = HexToPhase(eventcode);
        voltage = true;
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Over current
    if (eventcode < 10) {
        evtdata[0] = "A";
        evtdata[1] = ReasonToText(3);
        evtdata[2] = HexToPhase(eventcode);
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Unknown
    if (eventcode < 10) {
        evtdata[0] = "-";
        evtdata[1] = ReasonToText(0);
        evtdata[2] = HexToPhase(eventcode);
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Overvoltage LL
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(1);
        evtdata[2] = HexToPhase(eventcode + 10);
        voltage = true;
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Undervoltage LL
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(2);
        evtdata[2] = HexToPhase(eventcode + 10);
        voltage = true;
        return evtdata;
    }

    eventcode = eventcode / 10;

    //Voltage disruption LL
    if (eventcode < 10) {
        evtdata[0] = "V";
        evtdata[1] = ReasonToText(4);
        evtdata[2] = HexToPhase(eventcode + 10);
        voltage = true;
        return evtdata;
    }
    
   
    return evtdata;
}

////////////////////////////////////////////
// HEXTOPHASE: convert hex to phase
////////////////////////////////////////////
function HexToPhase(i) {
    if (i === 1)
        return "L1";
    if (i === 2)
        return "L2";
    if (i === 4)
        return "L3";
    if (i === 8)
        return "L4";
    if (i === 11)
        return "L1-L2";
    if (i === 12)
        return "L2-L3";
    if (i === 14)
        return "L3-L1";
}

////////////////////////////////////////////
// HEXTOPHASE: convert binary reason to text
////////////////////////////////////////////
function ReasonToText(i) {
    if (i === 0)
        return tl("-");
    if (i === 1)
        return tl("events.overvoltage");
    if (i === 2)
        return tl("events.undervoltage");
    if (i === 3)
        return tl("events.overcurrent");
    if (i === 4)
        return tl("events.voltageoff");

}

function PadZeros(i, len) {
    var s = i.toString();
    var erg = "";
    for (var d = 0; d < len - s.length; d++)
        erg += "0";
    return erg + s;
}


function eventlist_click(evt) {

    console.log('Op event geklikt');
    if (locked) {
        alert(tl("event.wait"));
    } else {
        locked = true;
        $("#eventgraph").empty();
        $("#overviewLegend").empty();
        $("#loader").show();

        evt = (evt) ? evt : ((window.event) ? window.event : "");
        var elem = (evt.target) ? evt.target : evt.srcElement;

        if (SelectedEventElement) {
            removeStyleClass(SelectedEventElement, "eventitem_selected");
        }

        var iHWW = parseInt(elem.getAttribute("name"));
        var evtdata = convertreason(eventdata[iHWW][6]);

        fillspan("info_starttime", timestrActual(eventdata[iHWW][0]));
        fillspan("info_duration", readableSeconds(eventdata[iHWW][1] - eventdata[iHWW][0]));
        fillspan("info_phase", "L" + evtdata[2]);
        fillspan("info_bound", eventdata[iHWW][2] + " " + evtdata[0]);
        fillspan("info_maxval", eventdata[iHWW][3] + " " + evtdata[0]);
        fillspan("info_minval", eventdata[iHWW][4] + " " + evtdata[0]);
        fillspan("info_avg", eventdata[iHWW][5] + " " + evtdata[0]);
        fillspan("info_reason", evtdata[1]);

        //Grafieklijnen (HWW's) zoeken bij event
        graphs = FindHwwForEvent(eventdata[iHWW]);

        
        graphdata = {};
        GetGraphData(result, 0);

        addStyleClass(elem, "eventitem_selected");
        SelectedEventElement = elem;
    }
}

function fillspan(id, txt) {
    var obj = document.getElementById(id);
    if (obj)
        obj.innerHTML = txt;
}

function FindHwwForEvent(Event) {
    var list = [];

    console.log(hwwdata);

    for (var i in hwwdata) {
        if (i in Array.prototype) {
            continue;
        }
        if (Event[0] < hwwdata[i][1] && Event[1] > hwwdata[i][0]) {
            list.push(parseInt(i));
        }
    }
    return list;
}

///////////////////////////////////////
// Loops through the available graphs for the selected event and downloads the data
///////////////////////////////////////
function GetGraphData(channel) {

    var graphcount = graphs.length;

    if (graphcount > 1) {
        graphcount = 1;
    }
    ;

    if (graphcount === 0) {
        $("#eventgraph").empty();
        $("#eventgraph").html("<div style='text-align: center;padding-top: 75px;'>" + tl("event.nodata") + "</div>");
        $("#loader").hide();

        locked = false;
    } else {

        if (number <= 7) {
            $.getJSON("../../lib/events/mk_hww.html?_hww_nr=" + graphs[0] + "&_val_nr=" + number, function (data) {
                //add graphdata to the array
                graphdata['d' + number] = data;
                //add the label to the array
                graphdata['d' + number]['label'] = getChannelName(number);
                //check if voltage or current

                if (number > 3) {
                    graphdata['d' + number]['yaxis'] = 2;
                }

                GetGraphData(graphs, number + 1);
            });
        } else {
            showhww();
            locked = false;
        }
    }
}

function getChannelName(i) {
    switch (i) {
        case 0:
            return tl("menu.voltage") + " " + tl("L1");
        case 4:
            return tl("menu.current") + " " + tl("L1");
        case 1:
            return tl("menu.voltage") + " " + tl("L2");
        case 5:
            return tl("menu.current") + " " + tl("L2");
        case 2:
            return tl("menu.voltage") + " " + tl("L3");
        case 6:
            return tl("menu.current") + " " + tl("L3");
        case 3:
            return tl("menu.voltage") + " " + tl("L4");
        case 7:
            return tl("menu.current") + " " + tl("L4");
        default:
            return i;
    }
}


function showhww() {

    var i = 0, choiceContainer = $("#overviewLegend");
    choiceContainer.empty();

    console.log(graphdata);

    $.each(graphdata, function (key, val) {
        val.color = i;
        ++i;
        l = val.label;
        var li = $('<li />').appendTo(choiceContainer);

        $('<input name="' + l + '" id="' + l + '" type="checkbox" checked="checked" />').appendTo(li);
        $('<label>', {
            text: l,
            'for': l
        }).appendTo(li);
    });

    $("#loader").hide();
    var container = document.getElementById('eventgraph');
    var d1 = [];
    var i, graph;

    var options = {
        linewidth: 1,
        xaxis: {
            minorTickFreq: 4,
            mode: "time",
            timeMode: "local",
            timeUnit: 'second'
        },
        yaxis: {
            tickFormatter: function (val, axis) {
                return val + "V";
            },
            autoscale: true
        },
        y2axis: {
            tickFormatter: function (val, axis) {
                return val + "A";
            },
            autoscale: true
        },
        grid: {
            minorVerticalLines: true
        },
        mouse: {
            track: true,
            relative: true,
            sensibility: 10,
            radius: 5,
            trackFormatter: function (obj) {

                var time = new Date(obj.nearest.x * 1000);
                var val = obj.nearest.series.label;
                var unit = "";
                if (obj.series.yaxis.n === 1) {
                    unit = "V"
                } else {
                    unit = "A"
                }

                return val + ', X: ' + dateFormat(time, "HH:MM:ss.l") + ', Y: ' + obj.y + unit;
            }
        },
        selection: {
            mode: 'x',
            fps: 30
        }, legend: {
            position: 'se'
        }
    };


    /// Draw graph with default options, overwriting with passed options
    function drawGraph(opts) {

        var data = [];

        choiceContainer.find("input:checked").each(function () {

            var key = this.name;
            for (var i = 0; i <= Object.keys(graphdata).length - 1; i++) {

                if (graphdata["d" + i].label === key) {
                    data.push(graphdata["d" + i]);
                    return true;
                }
            }
        });

        // Clone the options, so the 'options' variable always keeps intact.
        var o = Flotr._.extend(Flotr._.clone(options), opts || {});

        // Return a new graph.
        return Flotr.draw(container, data, o);
    }

    // Actually draw the graph.
    graph = drawGraph();
    choiceContainer.find("input").change(drawGraph);

    $('.flotr-legend-color-box > div').each(function (i) {
        $(this).clone().prependTo(choiceContainer.find("li").eq(i));
    });

    // Hook into the 'flotr:select' event.
    Flotr.EventAdapter.observe(container, 'flotr:select', function (area) {

        // Draw graph with new area
        graph = drawGraph({
            xaxis: {
                min: area.x1,
                max: area.x2,
                minorTickFreq: 4,
                mode: "time",
                timeMode: "local",
                timeUnit: 'second'
            },
            yaxis: {
                min: area.y1,
                max: area.y2,
                tickFormatter: function (val, axis) {
                    return val + "V";
                },
                autoscale: true
            }
        });
    });

    // When graph is clicked, draw the graph with default area.
    Flotr.EventAdapter.observe(container, 'flotr:click', function () {
        drawGraph();
    });

}

function addStyleClass(elem, cssClassName) {

    if (elem.className.indexOf(cssClassName) < 0)
        elem.className += " " + cssClassName;
}


function removeStyleClass(elem, cssClassName) {
    elem.className = elem.className.replace(cssClassName, "");
}