/*
 * Janitza Javascript library
 * Version: 2.1.0
 * Date: 24-3-2017
 */


//Initialisation
LIB_JS_VERSION = "2.1.0"; // 3 dots are nescessary by version test code!

window.onload = init;
////////////////////////////////////////////////////////////////////////////////
//MAIN INITALISATION FUNCTION
////////////////////////////////////////////////////////////////////////////////
function init() {
    //Add transient page
    menu[1].sub.push(transientMenuItem);
    //Create the Menu
    CreateMenu();
    //Start Translation
    Translate();
    //load other functions
    while (RegisterOnloadFunctionArray.length !== 0) {
        RegisterOnloadFunctionArray.shift()();
    }
    //System variables
    SysvarWorker();
}


////////////////////////////////////////////////////////////////////////////////
//CHECKS FOR FEATURE TOGGLES AND EDITS MENU IF NECESSARY
////////////////////////////////////////////////////////////////////////////////
const transientMenuItem = {
    "href": "/transients.html",
    'content': 'menu.transients',
    'img': '/img/icon_transient.png'

};

////////////////////////////////////////////////////////////////////////////////
//CREATES A UNIQUE ID FOR EVERY SYSVAR VALUE ON A PAGE
////////////////////////////////////////////////////////////////////////////////
function createid(length) {
//	return staticI++;
    var d = new Date();
    var a = "" + d.getTime();
    var b = "" + (Math.random() * length);
    var s = "";
    for (var i = 0; i < length; i++) {
        s += (i % 2 === 0) ? a.charAt(i % a.length) : b.charAt(i % b.length);
    }
    return s;
}

////////////////////////////////////////////////////////////////////////////////
//REGISTER FUNCTION WHICH HAVE TO LOAD AFTER THE REST IS LOADED
////////////////////////////////////////////////////////////////////////////////
var RegisterOnloadFunctionArray = new Array();
function RegisterOnloadFunction(func) {
    RegisterOnloadFunctionArray.push(func);
}
var RegisterUnloadFunctionArray = new Array();
function RegisterUnloadFunction(func) {
    RegisterUnloadFunctionArray.push(func);
}

////////////////////////////////////////////////////////////////////////////////
//RETURNS THE IP ADRES AS STRING
////////////////////////////////////////////////////////////////////////////////
function getIPAsString(doubleIP) {
    return (doubleIP >> 24 & 0xFF) + "." + (doubleIP >> 16 & 0xFF) + "." + (doubleIP >> 8 & 0xFF) + "." + (doubleIP & 0xFF);
}

////////////////////////////////////////////////////////////////////////////////
//RETURNS THE IP MODE
////////////////////////////////////////////////////////////////////////////////
function getIPMode(v_DHCPMODE) {
    var ret = "UNDEF";
    if (v_DHCPMODE === 0)
        ret = tl("info.fix_ip");
    if (v_DHCPMODE === 2 || v_DHCPMODE === 1)
        ret = "DHCP";
    return ret;
}

function uncache(url) {
    var d = new Date();
    var time = d.getTime();
    if (url.indexOf("?") > 0)
        delim = "&";
    else
        delim = "?";
    return url + delim + 'time=' + time;
}

////////////////////////////////////////////////////////////////////////////////
//MAIN MENU CREATION FUNCTION
////////////////////////////////////////////////////////////////////////////////
function CreateMenu() {
// GET NAVIGATION ITEM
    var navcon = $(".navigation");
    // LOOP menu.js for menu structure
    for (var i = 0; i < menu.length; i++) {
        
        if(menu[i].sub.length === 0){
            var li = createLiFromObj(menu[i].firstElement, 0);
            navcon.append(li);
        }else{
            var li = createLiFromObj(menu[i].firstElement, 1);
            navcon.append(li);
            var ul = $("<UL/>");
            ul.attr("class","dropdown-menu");
            for (var j = 0; j < menu[i].sub.length; j++) {
                var li2 = createSubLiFromObj(menu[i].sub[j]);
                ul.append(li2);
            }
            li.append(ul);
        }
       
    }
    
    $(".mainmenuitem > a").mouseenter(function(){
         if($(window).width() > 699){
            var source = $(this).find("img").attr("src");
            source = source.slice(0, -4);
            source = source + "-hover.png";
            $(this).find("img:first").attr("src",source);
         }
        
    });
    
    $(".mainmenuitem > a").mouseleave(function(){
        if($(window).width() > 699){
            var source = $(this).find("img").attr("src");
            source = source.slice(0, -10);
            source = source + ".png";
            $(this).find("img:first").attr("src",source);
        }
    });
    
}

////////////////////////////////////////////////////////////////////////////////
//CREATE INDIVIDUAL MENU ITEMS
////////////////////////////////////////////////////////////////////////////////
function createLiFromObj(obj, children) {
    var li = $("<li/>");
    li.attr("id", obj.id);
    li.attr("class", "mainmenuitem");
    
    var a = jQuery("<a/>");
    var img = $("<img/>");
    
    
    //check if it should have a child-menu
    if(children !== 0){
        li.attr("class", "mainmenuitem dropdown");
        a.attr("class", "dropdown-toggle");
        a.attr("data-toggle", "dropdown");
    }
   
     // if menu item has image add
    if (typeof(obj.img) !== "undefined") {
        img.addClass("menuimage");
        img.attr("src",obj.img);       
        a.append(img);
        a.append("<br>");
    }   
    
    // if menu text is available add 
    if (obj.content !== "") {
        a.append("<span>" + tl(obj.content) + "</span>");
    }
    // if link add
    if (typeof(obj.href) !== "undefined") {
        a.attr("href", obj.href);
    }
    li.append(a);
    return li;
}



////////////////////////////////////////////////////////////////////////////////
//CREATE INDIVIDUAL MENU SUBLEVEL ITEMS
////////////////////////////////////////////////////////////////////////////////
function createSubLiFromObj(obj) {
    var li = $("<li/>");
    li.attr("id", obj.id);
    li.attr("class", "dropdown");
    var a = jQuery("<a/>");
    var img = $("<img/>");
    
     // if menu item has image add
    if (typeof(obj.img) !== "undefined") {
        img.attr("src",obj.img);       
        a.append(img);
    }   
    
    // if menu text is available add 
    if (obj.content !== "") {
        a.append(tl(obj.content));
    }
    // if link add
    if (typeof(obj.href) !== "undefined") {
        a.attr("href", obj.href);
    }
    li.append(a);
    return li;
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Java-Script Library for UMG 600
// Graph-Routinen

function barover(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    var elem = (evt.target) ? evt.target : evt.srcElement;
    if (elem.alt && elem.alt.length >= 1)
        overlib(elem.alt);
}
function barout(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    var elem = (evt.target) ? evt.target : evt.srcElement;
    nd();
}
NOP = 0xFF00FF00;
function GraphImage(img) {
    return {
        "type": "image",
        "src": img
    };
}
////////////////////////////////////
function AxisOption() {
    this.name = "";
    this.unit = "";
    this.min = 0;
    this.max = 0;
    this.TeilerKl = 0;
    this.TeilerGr = 0;
    this.Xpx = 0;
    this.Ypx = 0;
    this.Objs = new Array();
}
AxisOption.prototype.delta = function() {
    return Math.abs(this.max - this.min);
};
//////////////////////////////////////////////////////
var xAxisStart = 10;
var xAxisWidth = 88; // Data width
var xAxisPaddingLeft = 3;
var xAxisPaddingRight = 1;
var xBar = 0.50;
var BAR_BORDER_WIDTH = 1;
var yAxisStart = 8;
var yAxisHeight = 75;
var yAxisPaddingTop = 5; //ex 3
var yAxisPaddingBottom = 10;
if (yAxisPaddingTop > yAxisStart) {
    Error.Debug("yAxisPaddingTop>yAxisStart ! Corrected: yAxisPaddingTop=yAxisStart");
    yAxisPaddingTop = yAxisStart;
}

if (yAxisStart + yAxisHeight + yAxisPaddingTop + yAxisPaddingBottom > 100) {
    Error.Warning("CGraph: yAxis-Sizeparamters exceeds 100%! Using Std-Values.");
    yAxisStart = 8;
    yAxisHeight = 75;
    yAxisPaddingTop = 3;
    yAxisPaddingBottom = 3;
}
function CGraph(id) {
    this.id = id;
    this.divNode = document.createElement("div");
    this.divNode.style.position = "absolute";
    this.divNode.style.top = "0px";
    this.divNode.style.left = "0px";
    this.divNode.style.width = "0px";
    this.divNode.style.height = "0px";
    this.divNode.style.margin = "0px";
    this.divNode.style.padding = "0px";
    this.textNode = this.divNode.cloneNode(true);
    this.bPrintXNumber = true;
    this.LegendenDiv = null;
    this.unit = "px";
    //Achsen:
    // y:
    this.YAxis = new AxisOption();
    this.XAxis = new AxisOption();
    this.bars = new Array();
    this.FontSize = "12pt";
    this.LineSize = "1";
    // 
}
CGraph.prototype.SetFontSize = function(size) {
    var old = this.FontSize;
    this.FontSize = size;
    return old;
};
CGraph.prototype.SetLineSize = function(size) {
    var old = this.LineSize;
    this.LineSize = size;
    return old;
};
CGraph.prototype.ClearBars = function() {
    for (x in this.bars) {
        if (x in Array.prototype)
            continue;
        for (var i = 0; i < this.bars[x].length; i++) {
            this.el.removeChild(this.bars[x][i]);
        }
    }
    this.bars = [];
    while (this.LegendenDiv.hasChildNodes())
        this.LegendenDiv.removeChild(this.LegendenDiv.firstChild);
};
//CGraph.prototype.CreateBlob = function(name,count, color,border,BarShift){
CGraph.prototype.CreateDynBars = function(count, name, color, border, BarShift, suppressLegenden) {
    if (!BarShift)
        BarShift = 0;
    var oldunit = this.SetUnit("%");
    var oldfont = this.SetFontSize("8pt");
    this.bars[name] = new Array(count);
    var xBarWidth = (xAxisWidth / count);
    for (var i = 0; i < count; i++) {
        var el = this.bars[name][i] = this.Rectangle(xAxisStart + xBarWidth * i + BarShift + ((xBar * xBarWidth) / 2), 0, xBar * xBarWidth, 0);
        el.style.visibility = "hidden";
        el.style.background = color;
        el.style.borderColor = border;
        el.style.borderStyle = "solid";
        el.style.borderWidth = BAR_BORDER_WIDTH + "px";
        el.style.zIndex = 99;
        addEvent(el, "mouseover", barover);
        addEvent(el, "mouseout", barout);
    }
    if (!suppressLegenden) {
        var legenChild = document.createElement("DIV");
        var legenBox = document.createElement("DIV");
        legenBox.style.width = "8px";
        legenBox.style.height = "8px";
        legenBox.style.background = color;
        legenBox.style.borderColor = border;
        legenBox.style.borderStyle = "solid";
        legenBox.style.borderWidth = BAR_BORDER_WIDTH + "px";
        legenBox.style.marginTop = "3px";
        legenBox.style.marginRight = "5px";
        legenBox.style.cssFloat = "left";
        legenBox.style.styleFloat = "left";
        legenBox.style.fontSize = "2pt";
        legenBox.style.lineHeight = "2px";
        legenChild.style.cssFloat = "left";
        legenChild.style.styleFloat = "left";
        legenChild.style.marginRight = "30px";
        legenChild.appendChild(legenBox);
        legenChild.appendChild(document.createTextNode(name));
        this.LegendenDiv.appendChild(legenChild);
    }
    this.SetUnit(oldunit);
    this.SetFontSize(oldfont);
};
/*
 *
 * @return Object Height,Top, Visibitlity
 */
CGraph.prototype._CalcBar = function(value) {
    if (value === 0) {
        return {
            "Height": 0,
            "Top": 0,
            "Visibility": "hidden"
        };
    }
//Nulldurchgang in % von DeltaY
    var NULLPosY = ((0 - this.YAxis.min) / this.YAxis.delta());
    var PosDelta = this.YAxis.delta() * (1 - NULLPosY);
    var NegDelta = this.YAxis.delta() * NULLPosY;
    // Fitting:
    if (value > this.YAxis.max)
        value = this.YAxis.max * 1.04;
    if (value < this.YAxis.min)
        value = this.YAxis.min;
    if (value > 0) {
        var proOfYPos = (value - 0) / PosDelta; //this.YAxis.min
        if (NULLPosY < this.YAxis.min)
            NULLPosY = 0;
        var h = parseInt(this.perY((1 - NULLPosY) * yAxisHeight) * proOfYPos);
        return {
            "Height": h,
            "Top": (this.perY(yAxisStart) + this.perY(yAxisHeight - (NULLPosY) * yAxisHeight) - h),
            "Visibility": ((h > 1) ? "visible" : "hidden")
        };
    }
    if (value < 0) {
        var proOfYPos = Math.abs(value) / NegDelta;
        var h = parseInt(this.perY(NULLPosY * yAxisHeight) * proOfYPos);
        return {
            "Height": h,
            "Top": (this.perY(yAxisStart) + this.perY(yAxisHeight - NULLPosY * yAxisHeight)),
            "Visibility": ((h > 1) ? "visible" : "hidden")
        };
    }
    if (value > 0) {
        var OffsetNull = this.YAxis.min;
        if (OffsetNull >= 0) {// Null auf linie oder unsichbar darunter
// % von (?berstehenden) Bar auf Y-Achse
            var proOfY = (value - OffsetNull) / this.YAxis.delta();
            var h = this.perY(yAxisStart) - this.perY(yAxisPaddingTop) + parseInt(this.perY(yAxisHeight) * proOfY);
            return {
                "Height": h,
                "Top": (this.YAxis.Ypx - h),
                "Visibility": ((h > 1) ? "visible" : "hidden")
            };
        }
        else {
//Verschiebung der NULL-Achse
            var NULLPosY = ((0 - this.YAxis.min) / this.YAxis.delta()) * yAxisHeight;
            var proOfY = (value - OffsetNull) / this.YAxis.delta();
            var h = this.perY(yAxisStart) - this.perY(yAxisPaddingTop) + parseInt(this.perY(yAxisHeight) * proOfY);
            return {
                "Height": h,
                "Top": (this.YAxis.Ypx - h),
                "Visibility": ((h > 1) ? "visible" : "hidden")
            };
        }
    }
    return {
        "Height": 0,
        "Top": 0,
        "Visibility": "hidden"
    };
};
CGraph.prototype.UpdateBar = function(i, name, value, addalt, suppressAlt) {
    var _Bar = this._CalcBar(value);
    this.bars[name][i].style.visibility = _Bar.Visibility;
    if (_Bar.Height === 0)
        _Bar.Height = 1; // IE Fix
    this.bars[name][i].style.height = (_Bar.Height - 1) + "px";
    this.bars[name][i].style.top = (_Bar.Top) + "px";
    this.bars[name][i].style.clip = "rect(0pt, " + (parseFloat(this.bars[name][i].style.width) + BAR_BORDER_WIDTH * 2) + "px, " + (_Bar.Height + BAR_BORDER_WIDTH * 2) + "px, 0pt)";
    if (suppressAlt)
        this.bars[name][i].alt = addalt;
    else
        this.bars[name][i].alt = name + " " + (i + 1) + ": <nobr>" + tlnum(value) + " " + this.YAxis.unit + "</nobr> " + addalt;
};
CGraph.prototype.UpdateXAxis = function() {
    this.RemoveXAxis();
    this.DrawXAxis();
};
CGraph.prototype.RemoveXAxis = function() {
    for (var i = 0; i < this.XAxis.Objs.length; i++) {
        this.el.removeChild(this.XAxis.Objs[i]);
    }
    this.XAxis.Objs = new Array();
};
CGraph.prototype.UpdateYAxis = function() {
    this.RemoveYAxis();
    this.DrawYAxis();
};
CGraph.prototype.RemoveYAxis = function() {
    for (var i = 0; i < this.YAxis.Objs.length; i++) {
        this.el.removeChild(this.YAxis.Objs[i]);
    }
    this.YAxis.Objs = new Array();
};
CGraph.prototype.DrawYAxis = function() {
    var oldunit = this.SetUnit("%");
    var oldfont = this.SetFontSize("14pt");
    // Y-Achse Beschriftung
    if (typeof(this.YAxis.name) === "object" && this.YAxis.name.type === "image") {
        this.YAxis.Objs.push(this.Image(0, 1, this.YAxis.name.src));
    }
    else {
        this.YAxis.Objs.push(this.TextOutV(1, 15, 80, this.YAxis.name));
    }
    if (this.YAxis.unit !== "") {
        this.SetFontSize("10pt");
        this.YAxis.Objs.push(this.TextOut(1, yAxisStart - yAxisPaddingTop - 3, 2, "[" + this.YAxis.unit + "]"));
    }
// Max-Beschriftung
    this.YAxis.Objs.push(this.TextOut(xAxisStart - 10, yAxisStart, 10, tlnum(this.YAxis.max)));
    // Min-Beschriftung
    this.YAxis.Objs.push(this.TextOut(xAxisStart - 10, yAxisStart + yAxisHeight, 10, tlnum(this.YAxis.min)));
    // NULL-Beschriftung
    if (this.YAxis.min < 0 && this.YAxis.max > 0) {
        var NULLPosY = ((0 - this.YAxis.min) / this.YAxis.delta()) * yAxisHeight;
        this.YAxis.Objs.push(this.TextOut(xAxisStart - 2, yAxisStart + yAxisHeight - NULLPosY, 1, "0"));
        this.YAxis.Objs.push(this.LineH(xAxisStart - 2, yAxisStart + yAxisHeight - NULLPosY, xAxisWidth + 2));
    }
    this.SetFontSize("14pt");
    // Y-Achse
    this.YAxis.Objs.push(this.LineV(xAxisStart, yAxisStart - yAxisPaddingTop, yAxisHeight + yAxisPaddingTop + yAxisPaddingBottom));
    //this.LineV(xAxisStart+1, yAxisStart-yAxisPaddingTop  ,yAxisPaddingTop  )
    //this.LineV(xAxisStart+1, yAxisStart+yAxisHeight  ,yAxisPaddingBottom  )
    for (var i = 1; i <= this.YAxis.TeilerKl; i++) {
        this.YAxis.Objs.push(this.LineH(xAxisStart - 1, yAxisStart + (yAxisHeight / this.YAxis.TeilerKl) * i, 1));
    }
    for (var i = 0; i < this.YAxis.TeilerGr; i++) {
        this.YAxis.Objs.push(this.LineH(xAxisStart - 3, yAxisStart + (yAxisHeight / this.YAxis.TeilerGr) * i, 3));
        this.SetBackground("gray");
        this.YAxis.Objs.push(this.LineH(xAxisStart, yAxisStart + (yAxisHeight / this.YAxis.TeilerGr) * i, xAxisWidth));
    }
    this.SetUnit(oldunit);
    this.SetFontSize(oldfont);
};
CGraph.prototype.DrawXAxis = function() {
    var oldunit = this.SetUnit("%");
    var oldfont = this.SetFontSize("14pt");
    //x-Axis
    this.XAxis.Objs.push(this.LineH(xAxisStart - xAxisPaddingLeft, yAxisStart + yAxisHeight, xAxisWidth + xAxisPaddingLeft + xAxisPaddingRight));
    this.YAxis.Ypx = this.perY(yAxisStart + yAxisHeight);
    // Beschriftung
    this.XAxis.Objs.push(this.TextOut(xAxisStart + 20, 90, 100 - xAxisStart, this.XAxis.name));
    for (var i = 0; i < this.XAxis.TeilerKl; i++) {
        this.XAxis.Objs.push(this.LineV(xAxisStart + (xAxisWidth / this.XAxis.TeilerKl) * i, yAxisStart + yAxisHeight, 1));
    }
    this.SetFontSize("8pt");
    for (var i = 0; i < this.XAxis.TeilerGr; i++) {
        this.XAxis.Objs.push(this.LineV(xAxisStart + (xAxisWidth / (this.XAxis.TeilerGr)) * (i + 1), yAxisStart + yAxisHeight - 1, 3));
        if (this.bPrintXNumber)
            this.XAxis.Objs.push(this.TextOut(xAxisStart + (xAxisWidth / this.XAxis.TeilerGr) * i, yAxisStart + yAxisHeight + 1, 2, (i + 1)));
    }
    this.SetUnit(oldunit);
    this.SetFontSize(oldfont);
};
CGraph.prototype.setYAxisUnit = function(newuint) {
    this.YAxis.unit = newuint;
};
CGraph.prototype.Init = function() {
    this.el = document.getElementById(this.id);
    this.width = parseInt(this.el.style.width);
    this.height = parseInt(this.el.style.height);
    ////////////////////
    // Y-Axis
    // Unit:
    this.DrawYAxis();
    this.DrawXAxis();
    // Legenden Box
    this.LegendenDiv = document.createElement("DIV");
    this.LegendenDiv.id = "legende";
    this.LegendenDiv.style.position = "absolute";
    this.LegendenDiv.style.left = this.perX(xAxisStart + 1) + "px";
    this.LegendenDiv.style.top = this.perY(100 - 8) + "px";
    this.LegendenDiv.style.width = this.perX(100 - yAxisStart - xAxisPaddingRight) + "px";
    this.LegendenDiv.style.zIndex = 220;
    this.el.appendChild(this.LegendenDiv);
};
CGraph.prototype.SetYAxis = function(name, unit, min, max) {
    if ((name) !== NOP)
        this.YAxis.name = name;
    if ((unit) !== NOP)
        this.YAxis.unit = unit;
    if ((min) !== NOP)
        this.YAxis.min = min;
    if ((max) !== NOP)
        this.YAxis.max = max;
};
CGraph.prototype.SetYAxisMarkerFac = function(kl, gr) {
    this.YAxis.TeilerKl = kl;
    this.YAxis.TeilerGr = gr;
};
CGraph.prototype.SetXAxis = function(name, unit, min, max) {
    if ((name) !== NOP)
        this.XAxis.name = name;
    if ((unit) !== NOP)
        this.XAxis.unit = unit;
    if ((min) !== NOP)
        this.XAxis.min = min;
    if ((max) !== NOP)
        this.XAxis.max = max;
};
CGraph.prototype.SetXAxisMarkerFac = function(kl, gr) {
    this.XAxis.TeilerKl = kl;
    this.XAxis.TeilerGr = gr;
};
CGraph.prototype.SetUnit = function(unit) {
    var ret = this.unit;
    this.unit = unit;
    return ret;
};
CGraph.prototype.SetBackground = function(color) {
    this.divNode.style.background = color;
};
/**
 * @param Percentage of Width
 * @return number of pixel
 */
CGraph.prototype.perX = function(perw) {
    return (perw / 100) * this.width;
};
/**
 * @param Percentage of Height
 * @return number of pixel
 */

CGraph.prototype.perY = function(perw) {
    return (perw / 100) * this.height;
};
CGraph.prototype.TextOutV = function(x1, y1, height, text) {
    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
        height = this.perY(height);
    }
    /*OLDvar s="";
     for(var i=0;i<text.length;i++) s+=text.charAt(i)+"<br>";
     var textNode= this.textNode.cloneNode(true);
     textNode.style.left = x1+"px";
     textNode.style.top = y1+"px";
     textNode.style.width = 10+"px";
     textNode.style.fontSize = this.FontSize;
     textNode.style.lineHeight= "80%";
     textNode.style.textAlign="center";
     textNode.innerHTML = s;
     this.el.appendChild(textNode);
     */
    var node = document.createElement("DIV");
    for (var i = 0; i < text.length; i++) {
        var textNode = this.textNode.cloneNode(true);
        textNode.style.left = x1 + "px";
        textNode.style.top = y1 + (i * (parseInt(this.FontSize) * (1 / 72) * 121)) + "px";
        textNode.style.width = 10 + "px";
        textNode.style.height = height + "px";
        textNode.style.fontSize = this.FontSize;
        textNode.style.lineHeight = "80%";
        textNode.style.textAlign = "left";
        textNode.innerHTML = text.charAt(i);
        node.appendChild(textNode);
    }
    this.el.appendChild(node);
    return node;
};
CGraph.prototype.TextOut = function(x1, y1, width, text) {
    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
        width = this.perX(width);
    }
    var textNode = this.textNode.cloneNode(true);
    textNode.style.left = x1 + "px";
    textNode.style.top = y1 + "px";
    textNode.style.width = width + "px";
    textNode.style.fontSize = this.FontSize;
    textNode.style.textAlign = "center";
    textNode.innerHTML = text;
    this.el.appendChild(textNode);
    return textNode;
};
////////////////////////////////////////////////////////////////////
// Draws a Rectangle to the Canvas:
// Parameter:
// x1,y1 - First Point, upper left
// x2,y2 - Second Point, lower right
// If SetUnit is set to "%" the pixel values will be calculated.
// Return: Created node
CGraph.prototype.Rectangle = function(x1, y1, width, height) {
    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
        width = this.perX(width);
        height = this.perY(height);
    }
    var node = this.divNode.cloneNode(true);
    node.style.left = x1 + "px";
    node.style.top = y1 + "px";
    node.style.width = width + "px";
    node.style.height = height + "px";
    node.style.clip = "rect(0pt, " + (width) + "px, " + (height) + "px, 0pt)";
    this.el.appendChild(node);
    return node;
};
////////////////////////////////////////////////////////////////////
// Draws a horizontal Line to the Canvas:
// Parameter:
// x1,y1 - Start Point
// w - Length
// If SetUnit is set to "%" the pixel values will be calculated.
// Return: Created node
CGraph.prototype.LineH = function(x1, y1, w) {
    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
        w = this.perX(w);
    }

    var node = this.divNode.cloneNode(true);
    factor = 1;
    unit = "px";
    node.style.left = x1 * factor + unit;
    node.style.top = y1 * factor + unit;
    node.style.width = w * factor + unit;
    node.style.height = this.LineSize * factor + unit;
    node.style.clip = "rect(0pt, " + w * factor + unit + ", " + this.LineSize * factor + unit + ", 0pt)";
    node.innerHTML = " ";
    this.el.appendChild(node);
    return node;
};
/**
 * Draws a vertical Line to the Canvas:
 * Parameter:
 * x1,y1 - Start Point
 * w - Height
 * If SetUnit is set to "%" the pixel values will be calculated.
 * Return: Created node
 * @param {int} x1
 * @param {int} y1
 * @param {int} h
 * @return {DOM_Node}
 */
CGraph.prototype.LineV = function(x1, y1, h) {
    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
        h = this.perY(h);
    }
    var node = this.divNode.cloneNode(true);
    node = this.el.appendChild(node);
    node.style.left = x1 + "px";
    node.style.top = y1 + "px";
    node.style.width = this.LineSize + "px";
    node.style.height = h + "px";
    return node;
};
CGraph.prototype.Image = function(x1, y1, src) {

    if (this.unit === "%") {
        x1 = this.perX(x1);
        y1 = this.perY(y1);
    }
    var node = document.createElement("img");
    node.src = src;
    node = this.el.appendChild(node);
    node.style.position = "absolute";
    node.style.left = x1 + "px";
    node.style.top = y1 + "px";
    return node;
};
function tlnum(n) {
    return String(n).replace(/\./, getDecimalPoint());
}
var EventList = [];
function addEvent(obj, eventType, _function) {
    EventList.push([obj, eventType, _function]);
    if (obj.addEventListener) {
        obj.addEventListener(eventType, _function, false);
        return true;
    }
    else
    if (obj.attachEvent) {
        var retVal = obj.attachEvent("on" + eventType, _function);
        return retVal;
    }
    else {
        return false;
    }
}//////////////////////////////////////////////////////////////////////////////////
//VARIABLES
////////////////////////////////////////////////////////////////////////////////
STD_GENAUIGKEIT = 2;
STD_SIPREFIX = "";
var sysvartable = new Object();
var aktGenauigkeit = STD_GENAUIGKEIT;
var aktSiPrefix = STD_SIPREFIX;
var _lastSiPrefix = "";
UMG_MAX_INT = 2147483648 - 1;
AUTOUPDATE = {"type": "autoupdate"};
SCROLL = {"type": "scroll"};
DISPLAYTIME = {"type": "displaytime"};
HIDEUNIT = {"type": "hideunit"};
////////////////////////////////////////////////////////////////////////////////
//SYSVAR CALLER USING JAVASCIPT
//
//SAMPLES:
//
//sysvar("_ULN[0]")
//sysvar("_ULN[0]", 2)
//sysvar("_ULN[0]", 2, AUTOUPDATE)
//sysvar("_ULN[0]", 2, SCROLL)
//sysvar("_ULN[0]", 2, ["n"])
//sysvar("_ULN[0]", 2, ["kilo"])
//sysvar("_ULN[0]", 2, ["kilo"],AUTOUPDATE,HIDEUNIT)
////////////////////////////////////////////////////////////////////////////////
function sysvar(name, Params) {
    //CREATE A unique id
    var id = createid(14);
    var tmp = sysvarsplit(name);
    //ADD SYSVAR TO SYSVARTABLE
    sysvartable[id] = new _Sysvar();
    sysvartable[id].varname = tmp.varname;
    sysvartable[id].array = tmp.array;
    sysvartable[id].org = name;
    sysvartable[id].genauigkeit = aktGenauigkeit;
    sysvartable[id].Exponent = GetSIPrefixExponend(aktSiPrefix);
    sysvartable[id].siPrefix = aktSiPrefix;
    var className = "sysvar";
    //CHECK FOR ARGUMENTS
    for (var i = 1; i < sysvar.arguments.length; i++) {
        var param = sysvar.arguments[i];
        //Check if argument is a number, if yes set number of decimals
        if (typeof(param) === "number") {
            sysvartable[id].genauigkeit = param;
        }
        //Check if argument type is an object and and array, then set prefix 
        if (typeof(param) === "object" && param.constructor === Array) {
            sysvartable[id].Exponent = GetSIPrefixExponend(param[0]);
            sysvartable[id].siPrefix = (sysvartable[id].Exponent !== 1) ? param[0] : ""; // Nur wenn wirklich genutzt
        }
        //Check for autoupdate argument
        if (typeof(param.type) === "string" && param.type === "autoupdate") {
            className = "autoupdate";
        }
        //Check for autoupdatescroller argument
        if (typeof(param.type) === "string" && param.type === "scroll") {
            className = "autoupdatescroller";
        }
        //Check if argument is displaytime
        if (typeof(param.type) === "string" && param.type === DISPLAYTIME.type) {
            sysvartable[id].DisplayTime = true;
        }
        //Check if argument is hidunit
        if (typeof(param.type) === "string" && param.type === "hideunit") {
            sysvartable[id].hideunit = true;
        }
        //Check if argument is min
        if (typeof(param.type) === "string" && param.type === "min") {
            sysvartable[id].min = param;
        }
        //Check if argument is max
        if (typeof(param.type) === "string" && param.type === "max") {
            sysvartable[id].max = param;
        }
        //Check if argument is hook
        if (typeof(param.type) === "string" && param.type === "hook") {
            sysvartable[id].hook = param;
        }
    }

    //Return the following html code
    return '<span class="' + className + '" name="' + name + '" id="' + id + '" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>';
}


////////////////////////////////////////////////////////////////////////////////
//Function to split the sysvar name to check if it is an array or not
////////////////////////////////////////////////////////////////////////////////
function sysvarsplit(s) {
    var varname = s;
    var array = {
        "from": -1,
        "to": -1
    };
    var isAnArray = false;
    if (s.charAt(s.length - 1) === "]") {
        isAnArray = true;
        varname = s.substr(0, s.indexOf("["));
        array.str = s.substring(s.indexOf("["));
        if (s.indexOf("..") !== -1) {
//Fix: from should be 0 since return has no index clues
            array.from = 0; //(s.substring(s.indexOf("[") + 1, s.indexOf("..")));
            array.to = (s.substring(s.indexOf("..") + 2, s.indexOf("]")));
        }
        else {
            array.to = array.from = (s.substring(s.indexOf("[") + 1, s.indexOf("]")));
        }
    }
    if (!isAnArray) {
        return {
            "varname": varname

        };
    }
    else {
        return {
            "varname": varname,
            "array": array
        };
    }
}


////////////////////////////////////////////////////////////////////////////////
//SYSVAR OBJECT
//
//getURL: returns object for request url
//arraySTRING: returns array as string
////////////////////////////////////////////////////////////////////////////////
function _Sysvar() {
    this.DisplayTime = false;
    this.Time = 0;
    return this;
}
_Sysvar.prototype.getURL = function() {
    if (this.DisplayTime) {
        return [this.org, this.varname + "_T" + this.arrayString()];
    }
    return this.org;
};
_Sysvar.prototype.arrayString = function() {
    if (this.array) {
        return this.array.str;
    }
    return "";
};
////////////////////////////////////////////////////////////////////////////////
//FUNCTION TO GET THE RIGHT PREFIX
////////////////////////////////////////////////////////////////////////////////
function GetSIPrefixExponend(siPrefix) {
    if (typeof(SIPrefixShort[siPrefix]) === "number") {
        return SIPrefixExp[SIPrefixShort[siPrefix]];
    }
    if (typeof(SIPrefixLong[siPrefix.toLowerCase()]) === "number") {
        return SIPrefixExp[SIPrefixLong[siPrefix]];
    }
    return 0;
}
SIPrefixLong = {
    "yotta": 0,
    "zetta": 1,
    "exa": 2,
    "peta": 3,
    "tera": 4,
    "giga": 5,
    "mega": 6,
    "kilo": 7,
    "hecto": 8,
    "deca": 9,
    "deci": 10,
    "centi": 11,
    "milli": 12,
    "micro": 13,
    "nano": 14,
    "pico": 15
};
SIPrefixShort = {
    "Y": 0,
    "Z": 1,
    "E": 2,
    "P": 3,
    "T": 4,
    "G": 5,
    "M": 6,
    "k": 7,
    "h": 8,
    "da": 9,
    "d": 10,
    "c": 11,
    "m": 12,
    "u": 13,
    "n": 14,
    "p": 15
};
SIPrefixExp = new Array(24, 21, 18, 15, 12, 9, 6, 3, 2, 1, -1, -2, -3, -6, -9, -12);
////////////////////////////////////////////////////////////////////////////////
//MAIN SYSVAR FUNCTIONS, STARTS THE REQUEST FOR THE SYSTEM VARIABLES ON A PAGE
////////////////////////////////////////////////////////////////////////////////
function SysvarWorker() {
    //While loading the system variables display animation
    if (LOAD_ANIM_MS > 0) {
        loadAnim = setInterval("updateLoadAnim()", LOAD_ANIM_MS);
    }

    //LIST FOR STATIC SYSVARS
    var VarList = "";
    var VarList = new VarListBuilder();
    var sysvaritems = $(".sysvar");
    for (var i = 0; i < sysvaritems.length; i++) {
        VarList.Add(sysvartable[sysvaritems[i].id].getURL());
    }

    //LIST FOR AUTOUPDATE SYSVARS
    var AutoUpdateVarList = "";
    var AutoUpdateVarList = new VarListBuilder();
    var autoupdateitems = $(".autoupdate");
    for (var i = 0; i < autoupdateitems.length; i++) {
        if (sysvartable[autoupdateitems[i].id].DisplayTime) {
            autoupdateitems[i].onmouseover = sysvar_mouseover;
            autoupdateitems[i].onmouseout = sysvar_mouseout;
        }
        AutoUpdateVarList.Add(sysvartable[autoupdateitems[i].id].getURL());
    }

    var autoupdatescrolitems = $(".autoupdatescroller");
    for (i = 0; i < autoupdatescrolitems.length; i++) {
        if (sysvartable[autoupdatescrolitems[i].id].DisplayTime) {
            autoupdatescrolitems[i].onmouseover = sysvar_mouseover;
            autoupdatescrolitems[i].onmouseout = sysvar_mouseout;
        }
        AutoUpdateVarList.Add(sysvartable[autoupdatescrolitems[i].id].getURL());
        
    }

    //REQUEST STATIC SYSVARS
    if (sysvaritems.length !== 0) {
        var theurl = "/json.do?" + VarList.Build() + ",time=" + new Date().getTime();
        $.getJSON(theurl, sysvar_callback);
    }

    //REQUEST AUTOUPDATE SYSVARS
    if (autoupdateitems.length !== 0 || autoupdatescrolitems.length !== 0) {
        var theurl = "/json.do?" + AutoUpdateVarList.Build() + ",time=" + new Date().getTime();
        $.getJSON(theurl, autoupdate_callback);    
    }
}

function jsonrequest(theurl) {
    theurl = theurl + ",time=" + new Date().getTime();
    var data;
    $.ajax({
        dataType: "json",
        url: theurl,
        data: data,
        timeout: 15000
    }).done(function(data) {
        autoupdate_callback(data);
    }).fail(function(data) {
        alert('Error new request');
        console.log('Error, url: ' + theurl);
        console.log(data);
        setTimeout(function(){jsonrequest(theurl);},5000);
    });

}


////////////////////////////////////////////////////////////////////////////////
//ANIMATION WHEN FUNCTION IS NOT YET LOADED
////////////////////////////////////////////////////////////////////////////////
var loadAnim;
var loadAnimAr = ["|", "/", "--", "\\"];
var loadAnimArI = 0;
var loadAnimTick = 0;
var LOAD_ANIM_MS = 300;
var LOAD_ANIM_WAIT_TICKS = 2;
function updateLoadAnim() {
    if (loadAnimTick++ < LOAD_ANIM_WAIT_TICKS) {
        return;
    }
    var mChar = loadAnimAr[loadAnimArI++ % loadAnimAr.length];
    $(".sysvar").text(mChar);
    $(".autoupdate").text(mChar);
    $(".autoupdatescroller").text(mChar);
}

////////////////////////////////////////////////////////////////////////////////
// VARLIST BUILDER
// 
// THE VARLIST BUILDER CREATES A STRING FOR THE JSON REQUEST
////////////////////////////////////////////////////////////////////////////////
function VarListBuilder() {
    this.list = new Array();
}

VarListBuilder.prototype.Add = function(sysvars) {
//check if system variable available
    if (sysvars === null) {
        return false;
    }

//if the sysvar is an array
    if (typeof(sysvars) === "object" && sysvars.constructor === Array) {

        for (var i in sysvars) {
            this._Add(sysvars[i].toUpperCase());
        }
    }
// if the sysvar is not an array
    else {
        this._Add(sysvars);
    }
};
VarListBuilder.prototype._Add = function(s) {
    var varname = s;
    var array = {
        "from": 0,
        "to": 0
    };
    //check if sysvar is an array
    var isAnArray = false;
    //if it is an array
    if (s.charAt(s.length - 1) === "]") {
        isAnArray = true;
        varname = s.substr(0, s.indexOf("["));
        //if multiple values
        if (s.indexOf("..") !== -1) {
//Fix: from should be 0 since return has no index clues
            array.from = 0; //(s.substring(s.indexOf("[") + 1, s.indexOf("..")));
            array.to = (s.substring(s.indexOf("..") + 2, s.indexOf("]")));
        }
// if one value
        else {
            array.to = array.from = (s.substring(s.indexOf("[") + 1, s.indexOf("]")));
        }
    }

//if varname is not yet in list
    if (typeof(this.list[varname]) === "undefined") {
        if (!isAnArray) {
            this.list[varname] = {
                "varname": varname
            };
        }
        else {
            this.list[varname] = {
                "varname": varname,
                "array": array
            };
        }
    }
//if varname is already in list and is an array update from and to
    else if (isAnArray) {

//Update min/max	
//Fix: from should be 0 since return has no index clues
        this.list[varname].array.from = 0; // Math.min(this.list[varname].array.from, array.from);
        this.list[varname].array.to = Math.max(this.list[varname].array.to, array.to);
    }
};
VarListBuilder.prototype.Build = function() {
    var s = "";
    for (var obj in this.list) {
        if (obj in Array.prototype) {
            continue;
        }
        s += obj;
        if (typeof(this.list[obj].array) === "object")
            if (this.list[obj].array.from === this.list[obj].array.to) {
                s += "[" + this.list[obj].array.from + "]";
            }
            else {
                s += "[" + this.list[obj].array.from + ".." + this.list[obj].array.to + "]";
            }
        s += ",";
    }
    s = s.substr(0, s.length - 1);
    return s;
};
///////////////////////////////////////////////////////////////////////////////
//FUNCTION CALLED AFTER SUCCESFULL STATIC SYSVAR JSON REQUEST
///////////////////////////////////////////////////////////////////////////////
function sysvar_callback(responseText) {

    clearInterval(loadAnim);
    var Response = new CResponse();
    Response.parse(responseText);
    var ToDo = new Array();
    var sysvarobjects = $(".sysvar");
    for (var i = 0; i < sysvarobjects.length; i++) {
        var sysvarobj = {
            "varname": sysvartable[sysvarobjects[i].id].org,
            "value": Response.get(sysvartable[sysvarobjects[i].id])
        };
        var hookret = false;
        if (sysvartable[sysvarobjects[i].id].hook) {
            hookret = sysvartable[sysvarobjects[i].id].hook.func(sysvarobj);
        }
        if (hookret) {
            sysvarobjects[i].innerHTML = (!isNaN(parseInt(sysvarobj.value))) ? sysvarobj.value.replace(/\./, getDecimalPoint()) : sysvarobj.value;
        }
        else {
            sysvarobjects[i].innerHTML = Response.get(sysvartable[sysvarobjects[i].id]).replace(/\./, getDecimalPoint());
        }
        if (sysvartable[sysvarobjects[i].id].DisplayTime) {
            sysvartable[sysvarobjects[i].id].Time = Response.value(sysvartable[sysvarobjects[i].id].getURL()[1]);
        }
        HandleSysvarMinMax(sysvartable[sysvarobjects[i].id], sysvarobjects[i], Response.value(sysvartable[sysvarobjects[i].id]));
    }

    for (var i = 0; i < ToDo.length; i++) {
        ToDo[i][0].innerHTML = ToDo[i][1];
    }
    delete responseText;
    sysvar_loaded = true;
}

///////////////////////////////////////////////////////////////////////////////
//FUNCTION CALLED AFTER SUCCESFULL AUTOUPDATE SYSVAR JSON REQUEST
///////////////////////////////////////////////////////////////////////////////
function autoupdate_callback(data) {
    clearInterval(loadAnim);
    var AutoUpdateResponse = new CResponse();
    AutoUpdateResponse.parse(data);
    var ToDo = [];
    var autoupdateobjects = $(".autoupdate");
    for (var i = 0; i < autoupdateobjects.length; i++) {

        var value = String(AutoUpdateResponse.get(sysvartable[autoupdateobjects[i].id]));
        var sysvarobj = {
            "varname": sysvartable[autoupdateobjects[i].id].org,
            "value": value
        };
        var hookret = false;
        if (sysvartable[autoupdateobjects[i].id].hook) {
            hookret = sysvartable[autoupdateobjects[i].id].hook.func(sysvarobj);
        }

        if (hookret) {
            value = sysvarobj.value;
        }

        if (sysvartable[autoupdateobjects[i].id].varname === "_DIGIN_STAT") {
            value = value.replace("0", tl("info.off"));
            value = value.replace("1", tl("info.on"));
        }

        if (value.indexOf("NF") < 0) {
            autoupdateobjects[i].innerHTML = (!isNaN(parseInt(value))) ? value.replace(/\./, getDecimalPoint()) : value;
        }

        if (sysvartable[autoupdateobjects[i].id].DisplayTime) {




            var valueid = sysvartable[autoupdateobjects[i].id].getURL()[1];
            sysvartable[autoupdateobjects[i].id].Time = AutoUpdateResponse.value(valueid);
            //AutoUpdateResponse.value(sysvartable[autoupdateobjects[i].id].getURL()[1]);
        }

        HandleSysvarMinMax(sysvartable[autoupdateobjects[i].id], autoupdateobjects[i], AutoUpdateResponse.value(sysvartable[autoupdateobjects[i].id]));
    }


//AUTOUPDATESCROLLER
    var autoupdatescrollerobjects = $(".autoupdatescroller");
    for (var i = 0; i < autoupdatescrollerobjects.length; i++) {
        var ValueList = [];
        var spanlist = autoupdatescrollerobjects[i].getElementsByTagName("span");
        for (var X = 0; X < spanlist.length; X++) {
            ValueList[X] = spanlist[X].innerHTML;
        }
        var nxtValue = AutoUpdateResponse.get(sysvartable[autoupdatescrollerobjects[i].id]);
        if (sysvartable[autoupdatescrollerobjects[i].id].varname === "_DIGIN_STAT") {
            nxtValue = String(nxtValue).replace("0", tl("info.off"));
            nxtValue = String(nxtValue).replace("1", tl("info.on"));
        } else {
            nxtValue = String(nxtValue).replace(/\./, getDecimalPoint());
        }
        ValueList.unshift(nxtValue);
        if (ValueList.length > 3) {
            ValueList.pop();
        }
        var s = "";
        for (X = 0; X < ValueList.length; X++) {
            s += '<span class="auscroll' + X + '">' + ValueList[X] + '</span>';
        }
        ToDo[ToDo.length] = new Array(autoupdatescrollerobjects[i], s);
    }

    for (var i = 0; i < ToDo.length; i++) {
        ToDo[i][0].innerHTML = ToDo[i][1];
    }
    AutoUpdateResponse = null;
    //EXECUTE FUNCTION AGAIN
    setTimeout(function() {

        var AutoUpdateVarList = "";
        var AutoUpdateVarList = new VarListBuilder();
        var autoupdateitems = $(".autoupdate");
        for (var i = 0; i < autoupdateitems.length; i++) {
            AutoUpdateVarList.Add(sysvartable[autoupdateitems[i].id].getURL());
        }

        var autoupdatescrolitems = $(".autoupdatescroller");
        for (i = 0; i < autoupdatescrolitems.length; i++) {
            AutoUpdateVarList.Add(sysvartable[autoupdatescrolitems[i].id].getURL());
        }

        var theurl = "/json.do?" + AutoUpdateVarList.Build() + ",time=" + new Date().getTime();
        $.getJSON(theurl, autoupdate_callback);
        
    }, 1000);
}


///////////////////////////////////////////////////////////////////////////////
//FUNCTION CRESPONSE CONVERTS JSON TO USABLE ARRAY
///////////////////////////////////////////////////////////////////////////////
function CResponse() {
    this.res = new Array();
    this.warn = true;
}

CResponse.prototype.parse = function(responseText) {
    delete this.res;
    this.res = {};
    try {
        this.res = responseText;
    }
    catch (e) {
        return;
    }
};
CResponse.prototype.get = function(s, i) {
    var r = this.getvar(s, i);
    if (typeof(r) === "string") {
        return r;
    }
    if (typeof(s) === "object" && s.hideunit) {
        return r[0];
    }
    return r[0] + " " + r[1];
};
CResponse.prototype.getvar = function(s, i, set) {
    var tmp = 0;
    if (typeof(s) === "object") {

        s.varname = s.varname.toUpperCase();
        if (typeof(this.res[s.varname]) === "undefined") {
            return [0, "NF"];
        }

//array offset correction: Bsp _ULL_AVG[2..4], Zugriff auf _ULL_AVG[2] ist in der zur?ckgegebenen array an Pos 0 

        var arrayoffset = 0; // this.res[s.varname].array.from;
        if (s.array) {
            arrayoffset = s.array.from;
        }

        if (s.array) {

            if (typeof(set) !== "undefined") {
                if (typeof(set) === "string" && set.substr(0, 4) === "UNIT") {
                    this.res[s.varname][0][arrayoffset] = set.substr(4);
                } else {
                    this.res[s.varname][0][arrayoffset] = set;
                }
            }

            if (typeof(this.res[s.varname][0][arrayoffset]) !== "undefined") {
                var zahl = this.res[s.varname][0][arrayoffset];
            } else {
                var zahl = this.res[s.varname][0][0];
            }
        }
        else {

            if (typeof(set) !== "undefined") {
                this.res[s.varname][0] = set;
            }
            var zahl = this.res[s.varname][0];
        }

        if (isNaN(parseInt(zahl))) { // Sysvarstring:            		
            return "---";
        }

        zahl = zahl * Math.pow(10, s.Exponent * -1);
        var gerundet = String(Math.runde(zahl, s.genauigkeit));
        tmp = [gerundet, s.siPrefix + this.res[s.varname][1]];
    }
    else {

        try {
            if (s.charAt(s.length - 1) === "]") {
                var tmp = sysvarsplit(s);
                s = tmp.varname;
                i = tmp.array.from;
                if (typeof(this.res[s]) !== "undefined" && typeof(this.res[s][0]) === "object") {

                    if (typeof(set) !== "undefined") {
                        if (typeof(set) === "string" && set.substr(0, 4) === "UNIT") {
                            this.res[s][1] = set.substr(4);
                        }
                        else {
                            this.res[s][0][i] = set;
                        }
                    }
                    tmp = [this.res[s][0][i], this.res[s][1]];
                }
                else {
                    if (typeof(set) !== "undefined") {

                        if (typeof(set) === "string" && set.substr(0, 4) === "UNIT") {
                            this.res[s][1] = set.substr(4);
                        }
                        else {
                            this.res[s][0] = set;
                        }
                    }
                    if (typeof(this.res[s]) === "undefined") {
                        tmp = ["var not in response", ""];
                    }
                    else {
                        tmp = [this.res[s][0], this.res[s][1]];
                    }
                }
            } else {
                tmp = this.res[s];
            }
        }
        catch (e) {
            console.log(e);
        }

    }
    return tmp;
};
CResponse.prototype.value = function(s, i) {
    var x = this.getvar(s, i);
    return x[0];
};
function HandleSysvarMinMax(item, obj, value) {
    if (item.min) {
        if (value < item.min.value) {
            $(obj).addClass("sysvar_min");
        }
        else {
            $(obj).removeClass("sysvar_min");
        }
    }
    if (item.max) {
        if (value > item.max.value) {
            $(obj).addClass("sysvar_max");
        }
        else {
            $(obj).removeClass("sysvar_max");
        }
    }
}

CResponse.prototype.unit = function(s, i) {
    var x = this.getvar(s, i);
    return x[1];
};
CResponse.prototype.Max = function(s, _from, _to) {


    s = s.toUpperCase();
    ar = this.res[s][0];
    var from = 0;
    var to = ar.length;
    if (CResponse.prototype.Max.arguments.length >= 2)
        from = _from;
    if (CResponse.prototype.Max.arguments.length >= 3)
        to = _to;
    max = 0;
    for (var i = from; i < to; i++)
        if (ar[i] > max)
            max = ar[i];
    return max;
};
CResponse.prototype.Min = function(s, _from, _to) {

    s = s.toUpperCase();
    ar = this.res[s][0];
    if (CResponse.prototype.Min.arguments.length >= 2)
        from = _from;
    if (CResponse.prototype.Min.arguments.length >= 3)
        to = _to;
    min = ar[0];
    for (var i = from; i < to; i++)
        if (ar[i] < min)
            min = ar[i];
    return min;
};
Response = new CResponse();
///////////////////////////////////////////////////////////////////////////////
//GET CORRECT DOT FOR LANGAUGE
///////////////////////////////////////////////////////////////////////////////
var staticPoint = "";
function getDecimalPoint() {
    if (staticPoint !== "") {
        return staticPoint;
    }
    for (i = 0; i < RegisterLanguage.length; i++) {
        if (RegisterLanguage[i]["abbr"] === CurrentLanguage) {
            staticPoint = RegisterLanguage[i]["point"];
            return staticPoint;
        }
    }
}

///////////////////////////////////////////////////////////////////////////////
//FUNCTIONS TO ROUND VALUES TO A SPECIFIC AMOUNT
///////////////////////////////////////////////////////////////////////////////
Math.runde = function(x, n) {
    if (n === 0) {
        if (x > 0) {
            return Math.round(x - 0.5);
        } else if (x < 0) {
            return Math.round(x + 0.5);
        }
        return parseInt(x);
    }
    if (n < 1 || n > 14) {
        return false;
    }
    var e = Math.round(Math.pow(10, n));
    var k = (Math.round(x * e) / e).toString();
    if (k.indexOf(".") === -1) {
        k += ".";
    }
    k += e.toString().substring(1);
    return k.substring(0, k.indexOf(".") + n + 1);
};
Math.frunde = function(x, n) {
    return parseFloat(Math.runde(x, n));
};
///////////////////////////////////////////////////////////////////////////////
//FUNCTION FOR SYSVARS WITH MOUSEOVER
///////////////////////////////////////////////////////////////////////////////
function sysvar_mouseover(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    var elem = (evt.target) ? evt.target : evt.srcElement;
    var time = sysvartable[elem.id].Time;
    if(time > 0){
        return overlib(timestr(sysvartable[elem.id].Time), BGCOLOR, 'grey');
    }else{
        return null;
    }
    
}
function sysvar_mouseout() {
    nd();
}

///////////////////////////////////////////////////////////////////////////////
//FUNCTION RETURN A TIMESTRING
///////////////////////////////////////////////////////////////////////////////
function timestr(i) {  
        return new Date(i * 1000).toLocaleString();
}

///////////////////////////////////////////////////////////////////////////////
//SET THE AMOUNT OF NUMBERS BEHIND THE DOT FOR AN ENTIRE PAGE
///////////////////////////////////////////////////////////////////////////////
function SysvarStellenReset() {
    aktGenauigkeit = STD_GENAUIGKEIT;
}


function SysvarStellen(i) {
    if (typeof(i) === "undefined") {
        return SysvarStellenReset();
    }
    if (i > 4)
        i = 4; // Mehr kommt nicht vom System

    aktGenauigkeit = i;
}

function SysvarLastSiPrefix() {
    aktSiPrefix = _lastSiPrefix;
}

function SysvarSiPrefix(v) {
    if (typeof(v) === "undefined") {

        v = STD_SIPREFIX;
    }

    _lastSiPrefix = aktSiPrefix;
    if (typeof(v) === "object") {
        aktSiPrefix = v[0];
    }
    else {
        aktSiPrefix = v;
    }
}

function MIN(val) {
    return {"type": "min", "value": val};
}
function MAX(val) {
    return {"type": "max", "value": val};
}

function HOOK(func) {
    return {
        "type": "hook",
        "func": func
    };
}


var TableHelperList = [];
function TableHelper() {
    var AttrList = "";
    if (TableHelper.arguments.length >= 1) {
        var arg2 = TableHelper.arguments[0];
        for (var y in arg2) {
            if (y in Array.prototype) {
                continue;
            }
            AttrList += " " + y + " = \"" + arg2[y] + "\"";
        }
    }
    this.id = "tab" + createid(12);
    this.s = "<table id=\"" + this.id + "\" class=\"contenttable\" " + AttrList + ">";
    this.HeadOpen = false;
    this.RowOpen = false;
    this.TableClosed = false;
    this.RowCount = 0;
    TableHelperList.push(this);
}

TableHelper.prototype.AddRaw = function(Content) {
    if (!Content) {
        Content = "";
    }
    this.s += Content;
};
TableHelper.prototype.NewHeader = function() {

    if (this.RowOpen) {
        this.s += "</tr>";
        this.RowOpen = false;
    }
    if (this.HeadOpen) {
        this.s += "<tr>";
    }
    else {
        this.s += "<thead><tr>";
    }
    this.HeadOpen = true;
};
TableHelper.prototype.AddCell = function(Content) {

    if (!Content) {
        Content = "";
    }
    var AttrList = "";
    if (TableHelper.prototype.AddCell.arguments.length > 1 && typeof(TableHelper.prototype.AddCell.arguments[1]) !== "string") {
        var arg2 = TableHelper.prototype.AddCell.arguments[1];
        for (var y in arg2) {
            if (y in Array.prototype) {
                continue;
            }
            AttrList += " " + y + " = \"" + arg2[y] + "\"";
        }
    }
    this.s += "<td" + AttrList + ">" + Content + "</td>";
};
TableHelper.prototype.NewRow = function() {
    if (this.HeadOpen) {
        this.s += "</tr></thead>";
        this.HeadOpen = false;
    }
    if (this.RowOpen) {
        this.s += "</tr>";
    }
    this.RowCount++;
    var AttrList = "";
    if (TableHelper.prototype.NewRow.arguments.length >= 1) {
        var arg2 = TableHelper.prototype.NewRow.arguments[0];
        for (var y in arg2) {
            if (y in Array.prototype) {
                continue;
            }
            AttrList += " " + y + " = \"" + arg2[y] + "\"";
        }
    }
    if (this.RowCount % 2 === 0) {
        this.s += "<tr class=\"odd\" " + AttrList + ">";
    }
    else {
        this.s += "<tr " + AttrList + ">";
    }
    this.RowOpen = true;
};
TableHelper.prototype.flush = function() {

    if (this.RowOpen) {
        this.s += "</tr>";
        this.RowOpen = false;
    }
    if (this.HeadOpen) {
        this.s += "</tr></thead>";
        this.HeadOpen = false;
    }
    if (!this.TableClosed) {
        this.s += "</table>";
        this.TableClosed = true;
    }
    return this.s;
};
var agent = navigator.userAgent.toLowerCase();
var is_phone = (agent.indexOf('iphone') !== -1);
TableHelper.prototype.AddCellWithOverlib = function(Content, overlibstr, addpram) {
    var obj = {
        "onmouseout": "return nd();",
        "onmouseover": "return overlib('" + overlibstr.replace(/'/ig, "\\'") + "');"
    };
    if (is_phone) {
        obj.onmouseover = "return overlib('" + overlibstr.replace(/'/ig, "\\'") + "',TIMEOUT,5000);";
    }
    for (var x in addpram) {
        obj[x] = addpram[x];
    }
    this.AddCell(Content, obj);
}; ////////////////////////////////////////////////////////////////////////////////
// Translation
////////////////////////////////////////////////////////////////////////////////
var lang = new Array();
var TimeStrArray = new Array();
function Translate() {
    //Check if there is a language defined
    if (typeof(RegisterLanguage) === "undefined") {
        return;
    }

    // Create main nodes
    var Node = $('<li/>');
    var SecNode = $('<ul/>');
    SecNode.attr("class","languagedropdown dropdown-menu");
    Node.append(SecNode);
    //add languages to nodes
    for (var i = 0; i < RegisterLanguage.length; i++) {

        if (RegisterLanguage[i]["default"]) {
            continue;
        }

        if (RegisterLanguage[i]["abbr"] === CurrentLanguage) {
            var ta2 = $("<a/>");
            ta2.attr("class", "languagename");
            ta2.append(RegisterLanguage[i]["lang"]);
            ta2.attr("alt", RegisterLanguage[i]["abbr"]);
            ta2.attr("data-toggle", "dropdown");
            ta2.attr("class", "dropdown-toggle currentlanguage");
            Node.attr("alt", RegisterLanguage[i]["abbr"]);
            Node.attr("class", "dropup");
            

            Node.append(ta2);
            
            
        } else {
            var tli = $("<li/>");
            var ta2 = $("<a/>");
            ta2.attr("class", "languagename");
            ta2.append(RegisterLanguage[i]["lang"]);
            tli.attr("alt", RegisterLanguage[i]["abbr"]);
            ta2.attr("alt", RegisterLanguage[i]["abbr"]);
            tli.attr("class","dropdown");

            tli.append(ta2);
            tli.click(function() {
                location.href = location.pathname + "?_LANGUAGE=" + $(this).attr("alt") + "&time=" + new Date().getTime();
            });
            SecNode.append(tli);
        }
    }
    $("#languageselector").append(Node);
    TranslatePage();
}

function TranslatePage() {
    var transselects = $("select");
    for (var i = transselects.length - 1; i >= 0; i--) {
        for (var j = 0; j < transselects[i].options.length; j++) {
            transselects[i].options[j].text = tl(transselects[i].options[j].text);
        }
    }
    var transelements = $(".trans");
    for (var i = transelements.length - 1; i >= 0; i--) {
        if (!$(transelements[i]).is("select")) {
            var translation = document.createElement("span");
            translation.innerHTML = (tl(transelements[i].innerHTML));
            transelements[i].parentNode.replaceChild(translation, transelements[i]);
        }
    }
}

function mapIdsToArray(prefix, count) {
    var arr = {};
    var curLang = lang[lang.length - 1];
    for (var i = 1; i <= count; i++) {
        arr[i] = curLang[prefix + i];
    }
    return arr;
}


function tl(id) {
//Search Current language
    if (typeof((lang[0][1])) !== "undefined" && lang[0][1][id]) {
        return lang[0][1][id];
    }
// else Search Fallback language
    if (lang[1][id]) {
        return lang[1][id];
    }
// else return not translated
    return id;
}

function tlToFloat(n) {
    return String(n).replace(getDecimalPoint(), ".");
}

/**
 * Add a new entry to the Translationtable.
 * Only if abbr matches current language, change will have effect.
 * Example:
 * AddTranslation("de","info.lang.id","NeuesWort");
 * @param {Object} abbr
 * @param {Object} id
 * @param {Object} word
 */
function AddTranslation(abbr, id, word) {
    if (typeof(RegisterLanguage) === "undefined") {
        AlterLanguageDelay.push(["newtrans", abbr, id, word]);
        return;
    }
    if (CurrentLanguage === abbr) {
        lang[0][1][id] = word;
    }else if(abbr === 'en'){
        lang[1][id] = word;
    }
}

//\/////

//\  overLIB 4.21 - You may not remove or change this notice.

//\  Copyright Erik Bosrup 1998-2004. All rights reserved.

//\

//\  Contributors are listed on the homepage.

//\  This file might be old, always check for the latest version at:

//\  http://www.bosrup.com/web/overlib/

//\

//\  Please read the license agreement (available through the link above)

//\  before using overLIB. Direct any licensing questions to erik@bosrup.com.

//\

//\  Do not sell this as your own work or remove this copyright notice. 

//\  For full details on copying or changing this script please read the

//\  license agreement at the link above. Please give credit on sites that

//\  use overLIB and submit changes of the script so other people can use

//\  them as well.

//   $Revision: 1.119 $                $Date: 2005/07/02 23:41:44 $

//\/////

//\mini



////////

// PRE-INIT

// Ignore these lines, configuration is below.

////////

var olLoaded = 0;
var pmStart = 10000000;
var pmUpper = 10001000;
var pmCount = pmStart + 1;
var pmt = '';
var pms = new Array();
var olInfo = new Info('4.21', 1);
var FREPLACE = 0;
var FBEFORE = 1;
var FAFTER = 2;
var FALTERNATE = 3;
var FCHAIN = 4;
var olHideForm = 0; // parameter for hiding SELECT and ActiveX elements in IE5.5+ 

var olHautoFlag = 0; // flags for over-riding VAUTO and HAUTO if corresponding

var olVautoFlag = 0; // positioning commands are used on the command line

var hookPts = new Array(), postParse = new Array(), cmdLine = new Array(), runTime = new Array();
// for plugins

registerCommands('donothing,inarray,caparray,sticky,background,noclose,caption,left,right,center,offsetx,offsety,fgcolor,bgcolor,textcolor,capcolor,closecolor,width,border,cellpad,status,autostatus,autostatuscap,height,closetext,snapx,snapy,fixx,fixy,relx,rely,fgbackground,bgbackground,padx,pady,fullhtml,above,below,capicon,textfont,captionfont,closefont,textsize,captionsize,closesize,timeout,function,delay,hauto,vauto,closeclick,wrap,followmouse,mouseoff,closetitle,cssoff,compatmode,cssclass,fgclass,bgclass,textfontclass,captionfontclass,closefontclass');
////////

// DEFAULT CONFIGURATION

// Settings you want everywhere are set here. All of this can also be

// changed on your html page or through an overLIB call.

////////

//if (typeof ol_fgcolor=='undefined') var ol_fgcolor="#DADDDA";

//if (typeof ol_bgcolor=='undefined') var ol_bgcolor="#A5A8AA";

if (typeof ol_fgcolor === 'undefined')
    var ol_fgcolor = "lightgrey";
if (typeof ol_bgcolor === 'undefined')
    var ol_bgcolor = "lightgrey";
if (typeof ol_textcolor === 'undefined')
    var ol_textcolor = "#000000";
if (typeof ol_capcolor === 'undefined')
    var ol_capcolor = "white";
if (typeof ol_closecolor === 'undefined')
    var ol_closecolor = "white";
if (typeof ol_textfont === 'undefined')
    var ol_textfont = "Verdana,Arial,Helvetica";
if (typeof ol_captionfont === 'undefined')
    var ol_captionfont = "Verdana,Arial,Helvetica";
if (typeof ol_closefont === 'undefined')
    var ol_closefont = "Verdana,Arial,Helvetica";
if (typeof ol_textsize === 'undefined')
    var ol_textsize = "3";
if (typeof ol_captionsize === 'undefined')
    var ol_captionsize = "1";
if (typeof ol_closesize === 'undefined')
    var ol_closesize = "1";
if (typeof ol_width === 'undefined')
    var ol_width = "200";
if (typeof ol_border === 'undefined')
    var ol_border = "20";
if (typeof ol_cellpad === 'undefined')
    var ol_cellpad = 20;
if (typeof ol_offsetx === 'undefined')
    var ol_offsetx = 10;
if (typeof ol_offsety === 'undefined')
    var ol_offsety = 10;
if (typeof ol_text === 'undefined')
    var ol_text = "Default Text";
if (typeof ol_cap === 'undefined')
    var ol_cap = "";
if (typeof ol_sticky === 'undefined')
    var ol_sticky = 0;
if (typeof ol_background === 'undefined')
    var ol_background = "";
if (typeof ol_close === 'undefined')
    var ol_close = "Close";
if (typeof ol_hpos === 'undefined')
    var ol_hpos = RIGHT;
if (typeof ol_status === 'undefined')
    var ol_status = "";
if (typeof ol_autostatus === 'undefined')
    var ol_autostatus = 0;
if (typeof ol_height === 'undefined')
    var ol_height = -1;
if (typeof ol_snapx === 'undefined')
    var ol_snapx = 0;
if (typeof ol_snapy === 'undefined')
    var ol_snapy = 0;
if (typeof ol_fixx === 'undefined')
    var ol_fixx = -1;
if (typeof ol_fixy === 'undefined')
    var ol_fixy = -1;
if (typeof ol_relx === 'undefined')
    var ol_relx = null;
if (typeof ol_rely === 'undefined')
    var ol_rely = null;
if (typeof ol_fgbackground === 'undefined')
    var ol_fgbackground = "";
if (typeof ol_bgbackground === 'undefined')
    var ol_bgbackground = "";
if (typeof ol_padxl === 'undefined')
    var ol_padxl = 10;
if (typeof ol_padxr === 'undefined')
    var ol_padxr = 10;
if (typeof ol_padyt === 'undefined')
    var ol_padyt = 10;
if (typeof ol_padyb === 'undefined')
    var ol_padyb = 10;
if (typeof ol_fullhtml === 'undefined')
    var ol_fullhtml = 0;
if (typeof ol_vpos === 'undefined')
    var ol_vpos = BELOW;
if (typeof ol_aboveheight === 'undefined')
    var ol_aboveheight = 0;
if (typeof ol_capicon === 'undefined')
    var ol_capicon = "";
if (typeof ol_frame === 'undefined')
    var ol_frame = self;
if (typeof ol_timeout === 'undefined')
    var ol_timeout = 0;
if (typeof ol_function === 'undefined')
    var ol_function = null;
if (typeof ol_delay === 'undefined')
    var ol_delay = 0;
if (typeof ol_hauto === 'undefined')
    var ol_hauto = 0;
if (typeof ol_vauto === 'undefined')
    var ol_vauto = 0;
if (typeof ol_closeclick === 'undefined')
    var ol_closeclick = 0;
if (typeof ol_wrap === 'undefined')
    var ol_wrap = 0;
if (typeof ol_followmouse === 'undefined')
    var ol_followmouse = 1;
if (typeof ol_mouseoff === 'undefined')
    var ol_mouseoff = 0;
if (typeof ol_closetitle === 'undefined')
    var ol_closetitle = 'Close';
if (typeof ol_compatmode === 'undefined')
    var ol_compatmode = 0;
if (typeof ol_css === 'undefined')
    var ol_css = CSSOFF;
if (typeof ol_fgclass === 'undefined')
    var ol_fgclass = "";
if (typeof ol_bgclass === 'undefined')
    var ol_bgclass = "";
if (typeof ol_textfontclass === 'undefined')
    var ol_textfontclass = "";
if (typeof ol_captionfontclass === 'undefined')
    var ol_captionfontclass = "";
if (typeof ol_closefontclass === 'undefined')
    var ol_closefontclass = "";
////////

// ARRAY CONFIGURATION

////////



// You can use these arrays to store popup text here instead of in the html.

if (typeof ol_texts === 'undefined')
    var ol_texts = new Array("Text 0", "Text 1");
if (typeof ol_caps === 'undefined')
    var ol_caps = new Array("Caption 0", "Caption 1");
////////

// END OF CONFIGURATION

// Don't change anything below this line, all configuration is above.

////////











////////

// INIT

////////

// Runtime variables init. Don't change for config!

var o3_text = "";
var o3_cap = "";
var o3_sticky = 0;
var o3_background = "";
var o3_close = "Close";
var o3_hpos = RIGHT;
var o3_offsetx = 2;
var o3_offsety = 2;
var o3_fgcolor = "";
var o3_bgcolor = "";
var o3_textcolor = "";
var o3_capcolor = "";
var o3_closecolor = "";
var o3_width = 100;
var o3_border = 1;
var o3_cellpad = 2;
var o3_status = "";
var o3_autostatus = 0;
var o3_height = -1;
var o3_snapx = 0;
var o3_snapy = 0;
var o3_fixx = -1;
var o3_fixy = -1;
var o3_relx = null;
var o3_rely = null;
var o3_fgbackground = "";
var o3_bgbackground = "";
var o3_padxl = 0;
var o3_padxr = 0;
var o3_padyt = 0;
var o3_padyb = 0;
var o3_fullhtml = 0;
var o3_vpos = BELOW;
var o3_aboveheight = 0;
var o3_capicon = "";
var o3_textfont = "Verdana,Arial,Helvetica";
var o3_captionfont = "Verdana,Arial,Helvetica";
var o3_closefont = "Verdana,Arial,Helvetica";
var o3_textsize = "1";
var o3_captionsize = "1";
var o3_closesize = "1";
var o3_frame = self;
var o3_timeout = 0;
var o3_timerid = 0;
var o3_allowmove = 0;
var o3_function = null;
var o3_delay = 0;
var o3_delayid = 0;
var o3_hauto = 0;
var o3_vauto = 0;
var o3_closeclick = 0;
var o3_wrap = 0;
var o3_followmouse = 1;
var o3_mouseoff = 0;
var o3_closetitle = '';
var o3_compatmode = 0;
var o3_css = CSSOFF;
var o3_fgclass = "";
var o3_bgclass = "";
var o3_textfontclass = "";
var o3_captionfontclass = "";
var o3_closefontclass = "";
// Display state variables

var o3_x = 0;
var o3_y = 0;
var o3_showingsticky = 0;
var o3_removecounter = 0;
// Our layer

var over = null;
var fnRef, hoveringSwitch = false;
var olHideDelay;
// Decide browser version

var isMac = (navigator.userAgent.indexOf("Mac") !== -1);
var olOp = (navigator.userAgent.toLowerCase().indexOf('opera') > -1 && document.createTextNode); // Opera 7

var olNs4 = (navigator.appName === 'Netscape' && parseInt(navigator.appVersion) === 4);
var olNs6 = (document.getElementById) ? true : false;
var olKq = (olNs6 && /konqueror/i.test(navigator.userAgent));
var olIe4 = (document.all) ? true : false;
var olIe5 = false;
var olIe55 = false; // Added additional variable to identify IE5.5+

var docRoot = 'document.body';
// Resize fix for NS4.x to keep track of layer

if (olNs4) {

    var oW = window.innerWidth;
    var oH = window.innerHeight;
    window.onresize = function() {
        if (oW !== window.innerWidth || oH !== window.innerHeight)
            location.reload();
    };
}



// Microsoft Stupidity Check(tm).

if (olIe4) {

    var agent = navigator.userAgent;
    if (/MSIE/.test(agent)) {

        var versNum = parseFloat(agent.match(/MSIE[ ](\d\.\d+)\.*/i)[1]);
        if (versNum >= 5) {

            olIe5 = true;
            olIe55 = (versNum >= 5.5 && !olOp) ? true : false;
            if (olNs6)
                olNs6 = false;
        }

    }

    if (olNs6)
        olIe4 = false;
}



// Check for compatability mode.

if (document.compatMode && document.compatMode === 'CSS1Compat') {

    docRoot = ((olIe4 && !olOp) ? 'document.documentElement' : docRoot);
}



// Add window onload handlers to indicate when all modules have been loaded

// For Netscape 6+ and Mozilla, uses addEventListener method on the window object

// For IE it uses the attachEvent method of the window object and for Netscape 4.x

// it sets the window.onload handler to the OLonload_handler function for Bubbling

if (window.addEventListener)
    window.addEventListener("load", OLonLoad_handler, false);
else if (window.attachEvent)
    window.attachEvent("onload", OLonLoad_handler);
var capExtent;
////////

// PUBLIC FUNCTIONS

////////



// overlib(arg0,...,argN)

// Loads parameters into global runtime variables.

function overlib() {

    if (!olLoaded || isExclusive(overlib.arguments))
        return true;
    if (olCheckMouseCapture)
        olMouseCapture();
    if (over) {

        over = (typeof over.id !== 'string') ? o3_frame.document.all['overDiv'] : over;
        cClick();
    }



    // Load defaults to runtime.

    olHideDelay = 0;
    o3_text = ol_text;
    o3_cap = ol_cap;
    o3_sticky = ol_sticky;
    o3_background = ol_background;
    o3_close = ol_close;
    o3_hpos = ol_hpos;
    o3_offsetx = ol_offsetx;
    o3_offsety = ol_offsety;
    o3_fgcolor = ol_fgcolor;
    o3_bgcolor = ol_bgcolor;
    o3_textcolor = ol_textcolor;
    o3_capcolor = ol_capcolor;
    o3_closecolor = ol_closecolor;
    o3_width = ol_width;
    o3_border = ol_border;
    o3_cellpad = ol_cellpad;
    o3_status = ol_status;
    o3_autostatus = ol_autostatus;
    o3_height = ol_height;
    o3_snapx = ol_snapx;
    o3_snapy = ol_snapy;
    o3_fixx = ol_fixx;
    o3_fixy = ol_fixy;
    o3_relx = ol_relx;
    o3_rely = ol_rely;
    o3_fgbackground = ol_fgbackground;
    o3_bgbackground = ol_bgbackground;
    o3_padxl = ol_padxl;
    o3_padxr = ol_padxr;
    o3_padyt = ol_padyt;
    o3_padyb = ol_padyb;
    o3_fullhtml = ol_fullhtml;
    o3_vpos = ol_vpos;
    o3_aboveheight = ol_aboveheight;
    o3_capicon = ol_capicon;
    o3_textfont = ol_textfont;
    o3_captionfont = ol_captionfont;
    o3_closefont = ol_closefont;
    o3_textsize = ol_textsize;
    o3_captionsize = ol_captionsize;
    o3_closesize = ol_closesize;
    o3_timeout = ol_timeout;
    o3_function = ol_function;
    o3_delay = ol_delay;
    o3_hauto = ol_hauto;
    o3_vauto = ol_vauto;
    o3_closeclick = ol_closeclick;
    o3_wrap = ol_wrap;
    o3_followmouse = ol_followmouse;
    o3_mouseoff = ol_mouseoff;
    o3_closetitle = ol_closetitle;
    o3_css = ol_css;
    o3_compatmode = ol_compatmode;
    o3_fgclass = ol_fgclass;
    o3_bgclass = ol_bgclass;
    o3_textfontclass = ol_textfontclass;
    o3_captionfontclass = ol_captionfontclass;
    o3_closefontclass = ol_closefontclass;
    setRunTimeVariables();
    fnRef = '';
    // Special for frame support, over must be reset...

    o3_frame = ol_frame;
    if (!(over = createDivContainer()))
        return false;
    parseTokens('o3_', overlib.arguments);
    if (!postParseChecks())
        return false;
    if (o3_delay === 0) {

        return runHook("olMain", FREPLACE);
    } else {

        o3_delayid = setTimeout("runHook('olMain', FREPLACE)", o3_delay);
        return false;
    }

}



// Clears popups if appropriate

function nd(time) {

    if (olLoaded && !isExclusive()) {

        hideDelay(time); // delay popup close if time specified



        if (o3_removecounter >= 1) {
            o3_showingsticky = 0;
        }
        ;
        if (o3_showingsticky === 0) {

            o3_allowmove = 0;
            if (over !== null && o3_timerid === 0)
                runHook("hideObject", FREPLACE, over);
        } else {

            o3_removecounter++;
        }

    }



    return true;
}



// The Close onMouseOver function for stickies

function cClick() {

    if (olLoaded) {

        runHook("hideObject", FREPLACE, over);
        o3_showingsticky = 0;
    }

    return false;
}



// Method for setting page specific defaults.

function overlib_pagedefaults() {

    parseTokens('ol_', overlib_pagedefaults.arguments);
}





////////

// OVERLIB MAIN FUNCTION

////////



// This function decides what it is we want to display and how we want it done.

function olMain() {

    var layerhtml, styleType;
    runHook("olMain", FBEFORE);
    if (o3_background !== "" || o3_fullhtml) {

// Use background instead of box.

        layerhtml = runHook('ol_content_background', FALTERNATE, o3_css, o3_text, o3_background, o3_fullhtml);
    } else {

// They want a popup box.

        styleType = (pms[o3_css - 1 - pmStart] === "cssoff" || pms[o3_css - 1 - pmStart] === "cssclass");
        // Prepare popup background

        if (o3_fgbackground !== "")
            o3_fgbackground = "background=\"" + o3_fgbackground + "\"";
        if (o3_bgbackground !== "")
            o3_bgbackground = (styleType ? "background=\"" + o3_bgbackground + "\"" : o3_bgbackground);
        // Prepare popup colors

        if (o3_fgcolor !== "")
            o3_fgcolor = (styleType ? "bgcolor=\"" + o3_fgcolor + "\"" : o3_fgcolor);
        if (o3_bgcolor !== "")
            o3_bgcolor = (styleType ? "bgcolor=\"" + o3_bgcolor + "\"" : o3_bgcolor);
        // Prepare popup height

        if (o3_height > 0)
            o3_height = (styleType ? "height=\"" + o3_height + "\"" : o3_height);
        else
            o3_height = "";
        // Decide which kinda box.

        if (o3_cap === "") {

// Plain

            layerhtml = runHook('ol_content_simple', FALTERNATE, o3_css, o3_text);
        } else {

// With caption

            if (o3_sticky) {

// Show close text

                layerhtml = runHook('ol_content_caption', FALTERNATE, o3_css, o3_text, o3_cap, o3_close);
            } else {

// No close text

                layerhtml = runHook('ol_content_caption', FALTERNATE, o3_css, o3_text, o3_cap, "");
            }

        }

    }



// We want it to stick!

    if (o3_sticky) {

        if (o3_timerid > 0) {

            clearTimeout(o3_timerid);
            o3_timerid = 0;
        }

        o3_showingsticky = 1;
        o3_removecounter = 0;
    }



// Created a separate routine to generate the popup to make it easier

// to implement a plugin capability

    if (!runHook("createPopup", FREPLACE, layerhtml))
        return false;
    // Prepare status bar

    if (o3_autostatus > 0) {

        o3_status = o3_text;
        if (o3_autostatus > 1)
            o3_status = o3_cap;
    }



// When placing the layer the first time, even stickies may be moved.

    o3_allowmove = 0;
    // Initiate a timer for timeout

    if (o3_timeout > 0) {

        if (o3_timerid > 0)
            clearTimeout(o3_timerid);
        o3_timerid = setTimeout("cClick()", o3_timeout);
    }



// Show layer

    runHook("disp", FREPLACE, o3_status);
    runHook("olMain", FAFTER);
    return (olOp && event && event.type === 'mouseover' && !o3_status) ? '' : (o3_status != '');
}



////////

// LAYER GENERATION FUNCTIONS

////////

// These functions just handle popup content with tags that should adhere to the W3C standards specification.



// Makes simple table without caption

function ol_content_simple(text) {

    var cpIsMultiple = /,/.test(o3_cellpad);
    var txt = '<table width="' + o3_width + '" border="0" cellpadding="' + o3_border + '" cellspacing="0" ' + (o3_bgclass ? 'class="' + o3_bgclass + '"' : o3_bgcolor + ' ' + o3_height) + '><tr><td><table width="100%" border="0" ' + ((olNs4 || !cpIsMultiple) ? 'cellpadding="' + o3_cellpad + '" ' : '') + 'cellspacing="0" ' + (o3_fgclass ? 'class="' + o3_fgclass + '"' : o3_fgcolor + ' ' + o3_fgbackground + ' ' + o3_height) + '><tr><td valign="TOP"' + (o3_textfontclass ? ' class="' + o3_textfontclass + '">' : ((!olNs4 && cpIsMultiple) ? ' style="' + setCellPadStr(o3_cellpad) + '">' : '>')) + (o3_textfontclass ? '' : wrapStr(0, o3_textsize, 'text')) + text + (o3_textfontclass ? '' : wrapStr(1, o3_textsize)) + '</td></tr></table></td></tr></table>';
    set_background("");
    return txt;
}



// Makes table with caption and optional close link

function ol_content_caption(text, title, close) {

    var nameId, txt, cpIsMultiple = /,/.test(o3_cellpad);
    var closing, closeevent;
    closing = "";
    closeevent = "onmouseover";
    if (o3_closeclick === 1)
        closeevent = (o3_closetitle ? "title='" + o3_closetitle + "'" : "") + " onclick";
    if (o3_capicon !== "") {

        nameId = ' hspace = \"5\"' + ' align = \"middle\" alt = \"\"';
        if (typeof o3_dragimg !== 'undefined' && o3_dragimg)
            nameId = ' hspace=\"5\"' + ' name=\"' + o3_dragimg + '\" id=\"' + o3_dragimg + '\" align=\"middle\" alt=\"Drag Enabled\" title=\"Drag Enabled\"';
        o3_capicon = '<img src=\"' + o3_capicon + '\"' + nameId + ' />';
    }



    if (close !== "")
        closing = '<td ' + (!o3_compatmode && o3_closefontclass ? 'class="' + o3_closefontclass : 'align="RIGHT') + '"><a href="javascript:return ' + fnRef + 'cClick();"' + ((o3_compatmode && o3_closefontclass) ? ' class="' + o3_closefontclass + '" ' : ' ') + closeevent + '="return ' + fnRef + 'cClick();">' + (o3_closefontclass ? '' : wrapStr(0, o3_closesize, 'close')) + close + (o3_closefontclass ? '' : wrapStr(1, o3_closesize, 'close')) + '</a></td>';
    txt = '<table width="' + o3_width + '" border="0" cellpadding="' + o3_border + '" cellspacing="0" ' + (o3_bgclass ? 'class="' + o3_bgclass + '"' : o3_bgcolor + ' ' + o3_bgbackground + ' ' + o3_height) + '><tr><td><table width="100%" border="0" cellpadding="2" cellspacing="0"><tr><td' + (o3_captionfontclass ? ' class="' + o3_captionfontclass + '">' : '>') + (o3_captionfontclass ? '' : '<b>' + wrapStr(0, o3_captionsize, 'caption')) + o3_capicon + title + (o3_captionfontclass ? '' : wrapStr(1, o3_captionsize) + '</b>') + '</td>' + closing + '</tr></table><table width="100%" border="0" ' + ((olNs4 || !cpIsMultiple) ? 'cellpadding="' + o3_cellpad + '" ' : '') + 'cellspacing="0" ' + (o3_fgclass ? 'class="' + o3_fgclass + '"' : o3_fgcolor + ' ' + o3_fgbackground + ' ' + o3_height) + '><tr><td valign="TOP"' + (o3_textfontclass ? ' class="' + o3_textfontclass + '">' : ((!olNs4 && cpIsMultiple) ? ' style="' + setCellPadStr(o3_cellpad) + '">' : '>')) + (o3_textfontclass ? '' : wrapStr(0, o3_textsize, 'text')) + text + (o3_textfontclass ? '' : wrapStr(1, o3_textsize)) + '</td></tr></table></td></tr></table>';
    set_background("");
    return txt;
}



// Sets the background picture,padding and lots more. :)

function ol_content_background(text, picture, hasfullhtml) {

    if (hasfullhtml) {

        txt = text;
    } else {

        txt = '<table width="' + o3_width + '" border="0" cellpadding="0" cellspacing="0" height="' + o3_height + '"><tr><td colspan="3" height="' + o3_padyt + '"></td></tr><tr><td width="' + o3_padxl + '"></td><td valign="TOP" width="' + (o3_width - o3_padxl - o3_padxr) + (o3_textfontclass ? '" class="' + o3_textfontclass : '') + '">' + (o3_textfontclass ? '' : wrapStr(0, o3_textsize, 'text')) + text + (o3_textfontclass ? '' : wrapStr(1, o3_textsize)) + '</td><td width="' + o3_padxr + '"></td></tr><tr><td colspan="3" height="' + o3_padyb + '"></td></tr></table>';
    }



    set_background(picture);
    return txt;
}



// Loads a picture into the div.

function set_background(pic) {

    if (pic === "") {

        if (olNs4) {

            over.background.src = null;
        } else if (over.style) {

            over.style.backgroundImage = "none";
        }

    } else {

        if (olNs4) {

            over.background.src = pic;
        } else if (over.style) {

            over.style.width = o3_width + 'px';
            over.style.backgroundImage = "url(" + pic + ")";
        }

    }

}



////////

// HANDLING FUNCTIONS

////////

var olShowId = -1;
// Displays the popup

function disp(statustext) {

    runHook("disp", FBEFORE);
    if (o3_allowmove === 0) {

        runHook("placeLayer", FREPLACE);
        (olNs6 && olShowId < 0) ? olShowId = setTimeout("runHook('showObject', FREPLACE, over)", 1) : runHook("showObject", FREPLACE, over);
        o3_allowmove = (o3_sticky || o3_followmouse === 0) ? 0 : 1;
    }



    runHook("disp", FAFTER);
    if (statustext !== "")
        self.status = statustext;
}



// Creates the actual popup structure

function createPopup(lyrContent) {

    runHook("createPopup", FBEFORE);
    if (o3_wrap) {

        var wd, ww, theObj = (olNs4 ? over : over.style);
        theObj.top = theObj.left = ((olIe4 && !olOp) ? 0 : -10000) + (!olNs4 ? 'px' : 0);
        layerWrite(lyrContent);
        wd = (olNs4 ? over.clip.width : over.offsetWidth);
        if (wd > (ww == windowWidth())) {

            lyrContent = lyrContent.replace(/\&nbsp;/g, ' ');
            o3_width = ww;
            o3_wrap = 0;
        }

    }



    layerWrite(lyrContent);
    // Have to set o3_width for placeLayer() routine if o3_wrap is turned on

    if (o3_wrap)
        o3_width = (olNs4 ? over.clip.width : over.offsetWidth);
    runHook("createPopup", FAFTER, lyrContent);
    return true;
}



// Decides where we want the popup.

function placeLayer() {

    var placeX, placeY, widthFix = 0;
    // HORIZONTAL PLACEMENT, re-arranged to work in Safari

    if (o3_frame.innerWidth)
        widthFix = 18;
    iwidth = windowWidth();
    // Horizontal scroll offset

    winoffset = (olIe4) ? eval('o3_frame.' + docRoot + '.scrollLeft') : o3_frame.pageXOffset;
    placeX = runHook('horizontalPlacement', FCHAIN, iwidth, winoffset, widthFix);
    // VERTICAL PLACEMENT, re-arranged to work in Safari

    if (o3_frame.innerHeight) {

        iheight = o3_frame.innerHeight;
    } else if (eval('o3_frame.' + docRoot) && eval("typeof o3_frame." + docRoot + ".clientHeight=='number'") && eval('o3_frame.' + docRoot + '.clientHeight')) {

        iheight = eval('o3_frame.' + docRoot + '.clientHeight');
    }



// Vertical scroll offset

    scrolloffset = (olIe4) ? eval('o3_frame.' + docRoot + '.scrollTop') : o3_frame.pageYOffset;
    placeY = runHook('verticalPlacement', FCHAIN, iheight, scrolloffset);
    // Actually move the object.

    repositionTo(over, placeX, placeY);
}



// Moves the layer

function olMouseMove(e) {

    var e = (e) ? e : event;
    if (e.pageX) {

        o3_x = e.pageX;
        o3_y = e.pageY;
    } else if (e.clientX) {

        o3_x = eval('e.clientX+o3_frame.' + docRoot + '.scrollLeft');
        o3_y = eval('e.clientY+o3_frame.' + docRoot + '.scrollTop');
    }



    if (o3_allowmove === 1)
        runHook("placeLayer", FREPLACE);
    // MouseOut handler

    if (hoveringSwitch && !olNs4 && runHook("cursorOff", FREPLACE)) {

        (olHideDelay ? hideDelay(olHideDelay) : cClick());
        hoveringSwitch = !hoveringSwitch;
    }

}



// Fake function for 3.0 users.

function no_overlib() {
    return ver3fix;
}



// Capture the mouse and chain other scripts.

function olMouseCapture() {

    capExtent = document;
    var fN, str = '', l, k, f, wMv, sS, mseHandler = olMouseMove;
    var re = /function[ ]*(\w*)\(/;
    wMv = (!olIe4 && window.onmousemove);
    if (document.onmousemove || wMv) {

        if (wMv)
            capExtent = window;
        f = capExtent.onmousemove.toString();
        fN = f.match(re);
        if (fN === null) {

            str = f + '(e); ';
        } else if (fN[1] === 'anonymous' || fN[1] === 'olMouseMove' || (wMv && fN[1] === 'onmousemove')) {

            if (!olOp && wMv) {

                l = f.indexOf('{') + 1;
                k = f.lastIndexOf('}');
                sS = f.substring(l, k);
                if ((l = sS.indexOf('(')) !== -1) {

                    sS = sS.substring(0, l).replace(/^\s+/, '').replace(/\s+$/, '');
                    if (eval("typeof " + sS + " == 'undefined'"))
                        window.onmousemove = null;
                    else
                        str = sS + '(e);';
                }

            }

            if (!str) {

                olCheckMouseCapture = false;
                return;
            }

        } else {

            if (fN[1])
                str = fN[1] + '(e); ';
            else {

                l = f.indexOf('{') + 1;
                k = f.lastIndexOf('}');
                str = f.substring(l, k) + '\n';
            }

        }

        str += 'olMouseMove(e); ';
        mseHandler = new Function('e', str);
    }



    capExtent.onmousemove = mseHandler;
    if (olNs4)
        capExtent.captureEvents(Event.MOUSEMOVE);
}



////////

// PARSING FUNCTIONS

////////



// Does the actual command parsing.

function parseTokens(pf, ar) {

// What the next argument is expected to be.

    var v, i, mode = -1, par = (pf !== 'ol_');
    var fnMark = (par && !ar.length ? 1 : 0);
    for (i = 0; i < ar.length; i++) {

        if (mode < 0) {

// Arg is maintext,unless its a number between pmStart and pmUpper

// then its a command.

            if (typeof ar[i] === 'number' && ar[i] > pmStart && ar[i] < pmUpper) {

                fnMark = (par ? 1 : 0);
                i--; // backup one so that the next block can parse it

            } else {

                switch (pf) {

                    case 'ol_':

                        ol_text = ar[i].toString();
                        break;
                    default:

                        o3_text = ar[i].toString();
                }

            }

            mode = 0;
        } else {

// Note: NS4 doesn't like switch cases with vars.

            if (ar[i] >= pmCount || ar[i] === DONOTHING) {
                continue;
            }

            if (ar[i] === INARRAY) {
                fnMark = 0;
                eval(pf + 'text=ol_texts[' + ar[++i] + '].toString()');
                continue;
            }

            if (ar[i] === CAPARRAY) {
                eval(pf + 'cap=ol_caps[' + ar[++i] + '].toString()');
                continue;
            }

            if (ar[i] === STICKY) {
                if (pf !== 'ol_')
                    eval(pf + 'sticky=1');
                continue;
            }

            if (ar[i] === BACKGROUND) {
                eval(pf + 'background="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === NOCLOSE) {
                if (pf !== 'ol_')
                    opt_NOCLOSE();
                continue;
            }

            if (ar[i] === CAPTION) {
                eval(pf + "cap='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === CENTER || ar[i] === LEFT || ar[i] === RIGHT) {
                eval(pf + 'hpos=' + ar[i]);
                if (pf !== 'ol_')
                    olHautoFlag = 1;
                continue;
            }

            if (ar[i] === OFFSETX) {
                eval(pf + 'offsetx=' + ar[++i]);
                continue;
            }

            if (ar[i] === OFFSETY) {
                eval(pf + 'offsety=' + ar[++i]);
                continue;
            }

            if (ar[i] === FGCOLOR) {
                eval(pf + 'fgcolor="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === BGCOLOR) {
                eval(pf + 'bgcolor="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === TEXTCOLOR) {
                eval(pf + 'textcolor="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CAPCOLOR) {
                eval(pf + 'capcolor="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CLOSECOLOR) {
                eval(pf + 'closecolor="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === WIDTH) {
                eval(pf + 'width=' + ar[++i]);
                continue;
            }

            if (ar[i] === BORDER) {
                eval(pf + 'border=' + ar[++i]);
                continue;
            }

            if (ar[i] === CELLPAD) {
                i = opt_MULTIPLEARGS(++i, ar, (pf + 'cellpad'));
                continue;
            }

            if (ar[i] === STATUS) {
                eval(pf + "status='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === AUTOSTATUS) {
                eval(pf + 'autostatus=(' + pf + 'autostatus == 1) ? 0 : 1');
                continue;
            }

            if (ar[i] === AUTOSTATUSCAP) {
                eval(pf + 'autostatus=(' + pf + 'autostatus == 2) ? 0 : 2');
                continue;
            }

            if (ar[i] === HEIGHT) {
                eval(pf + 'height=' + pf + 'aboveheight=' + ar[++i]);
                continue;
            } // Same param again.

            if (ar[i] === CLOSETEXT) {
                eval(pf + "close='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === SNAPX) {
                eval(pf + 'snapx=' + ar[++i]);
                continue;
            }

            if (ar[i] === SNAPY) {
                eval(pf + 'snapy=' + ar[++i]);
                continue;
            }

            if (ar[i] === FIXX) {
                eval(pf + 'fixx=' + ar[++i]);
                continue;
            }

            if (ar[i] === FIXY) {
                eval(pf + 'fixy=' + ar[++i]);
                continue;
            }

            if (ar[i] === RELX) {
                eval(pf + 'relx=' + ar[++i]);
                continue;
            }

            if (ar[i] === RELY) {
                eval(pf + 'rely=' + ar[++i]);
                continue;
            }

            if (ar[i] === FGBACKGROUND) {
                eval(pf + 'fgbackground="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === BGBACKGROUND) {
                eval(pf + 'bgbackground="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === PADX) {
                eval(pf + 'padxl=' + ar[++i]);
                eval(pf + 'padxr=' + ar[++i]);
                continue;
            }

            if (ar[i] === PADY) {
                eval(pf + 'padyt=' + ar[++i]);
                eval(pf + 'padyb=' + ar[++i]);
                continue;
            }

            if (ar[i] === FULLHTML) {
                if (pf != 'ol_')
                    eval(pf + 'fullhtml=1');
                continue;
            }

            if (ar[i] === BELOW || ar[i] === ABOVE) {
                eval(pf + 'vpos=' + ar[i]);
                if (pf !== 'ol_')
                    olVautoFlag = 1;
                continue;
            }

            if (ar[i] === CAPICON) {
                eval(pf + 'capicon="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === TEXTFONT) {
                eval(pf + "textfont='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === CAPTIONFONT) {
                eval(pf + "captionfont='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === CLOSEFONT) {
                eval(pf + "closefont='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === TEXTSIZE) {
                eval(pf + 'textsize="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CAPTIONSIZE) {
                eval(pf + 'captionsize="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CLOSESIZE) {
                eval(pf + 'closesize="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === TIMEOUT) {
                eval(pf + 'timeout=' + ar[++i]);
                continue;
            }

            if (ar[i] === FUNCTION) {
                if (pf === 'ol_') {
                    if (typeof ar[i + 1] !== 'number') {
                        v = ar[++i];
                        ol_function = (typeof v === 'function' ? v : null);
                    }
                } else {
                    fnMark = 0;
                    v = null;
                    if (typeof ar[i + 1] !== 'number')
                        v = ar[++i];
                    opt_FUNCTION(v);
                }
                continue;
            }

            if (ar[i] === DELAY) {
                eval(pf + 'delay=' + ar[++i]);
                continue;
            }

            if (ar[i] === HAUTO) {
                eval(pf + 'hauto=(' + pf + 'hauto == 0) ? 1 : 0');
                continue;
            }

            if (ar[i] === VAUTO) {
                eval(pf + 'vauto=(' + pf + 'vauto == 0) ? 1 : 0');
                continue;
            }

            if (ar[i] === CLOSECLICK) {
                eval(pf + 'closeclick=(' + pf + 'closeclick == 0) ? 1 : 0');
                continue;
            }

            if (ar[i] === WRAP) {
                eval(pf + 'wrap=(' + pf + 'wrap == 0) ? 1 : 0');
                continue;
            }

            if (ar[i] === FOLLOWMOUSE) {
                eval(pf + 'followmouse=(' + pf + 'followmouse == 1) ? 0 : 1');
                continue;
            }

            if (ar[i] === MOUSEOFF) {
                eval(pf + 'mouseoff=(' + pf + 'mouseoff==0) ? 1 : 0');
                v = ar[i + 1];
                if (pf !== 'ol_' && eval(pf + 'mouseoff') && typeof v == 'number' && (v < pmStart || v > pmUpper))
                    olHideDelay = ar[++i];
                continue;
            }

            if (ar[i] === CLOSETITLE) {
                eval(pf + "closetitle='" + escSglQuote(ar[++i]) + "'");
                continue;
            }

            if (ar[i] === CSSOFF || ar[i] === CSSCLASS) {
                eval(pf + 'css=' + ar[i]);
                continue;
            }

            if (ar[i] === COMPATMODE) {
                eval(pf + 'compatmode=(' + pf + 'compatmode==0) ? 1 : 0');
                continue;
            }

            if (ar[i] === FGCLASS) {
                eval(pf + 'fgclass="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === BGCLASS) {
                eval(pf + 'bgclass="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === TEXTFONTCLASS) {
                eval(pf + 'textfontclass="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CAPTIONFONTCLASS) {
                eval(pf + 'captionfontclass="' + ar[++i] + '"');
                continue;
            }

            if (ar[i] === CLOSEFONTCLASS) {
                eval(pf + 'closefontclass="' + ar[++i] + '"');
                continue;
            }

            i = parseCmdLine(pf, i, ar);
        }

    }



    if (fnMark && o3_function)
        o3_text = o3_function();
    if ((pf === 'o3_') && o3_wrap) {

        o3_width = 0;
        var tReg = /<.*\n*>/ig;
        if (!tReg.test(o3_text))
            o3_text = o3_text.replace(/[ ]+/g, '&nbsp;');
        if (!tReg.test(o3_cap))
            o3_cap = o3_cap.replace(/[ ]+/g, '&nbsp;');
    }

    if ((pf === 'o3_') && o3_sticky) {

        if (!o3_close && (o3_frame !== ol_frame))
            o3_close = ol_close;
        if (o3_mouseoff && (o3_frame === ol_frame))
            opt_NOCLOSE(' ');
    }

}





////////

// LAYER FUNCTIONS

////////



// Writes to a layer

function layerWrite(txt) {

    txt += "\n";
    if (olNs4) {

        var lyr = o3_frame.document.layers['overDiv'].document;
        lyr.write(txt);
        lyr.close();
    } else if (typeof over.innerHTML !== 'undefined') {

        if (olIe5 && isMac)
            over.innerHTML = '';
        over.innerHTML = txt;
    } else {

        range = o3_frame.document.createRange();
        range.setStartAfter(over);
        domfrag = range.createContextualFragment(txt);
        while (over.hasChildNodes()) {

            over.removeChild(over.lastChild);
        }



        over.appendChild(domfrag);
    }

}



// Make an object visible

function showObject(obj) {

    runHook("showObject", FBEFORE);
    var theObj = (olNs4 ? obj : obj.style);
    theObj.visibility = 'visible';
    runHook("showObject", FAFTER);
}



// Hides an object

function hideObject(obj) {

    runHook("hideObject", FBEFORE);
    var theObj = (olNs4 ? obj : obj.style);
    if (olNs6 && olShowId > 0) {
        clearTimeout(olShowId);
        olShowId = 0;
    }

    theObj.visibility = 'hidden';
    theObj.top = theObj.left = ((olIe4 && !olOp) ? 0 : -10000) + (!olNs4 ? 'px' : 0);
    if (o3_timerid > 0)
        clearTimeout(o3_timerid);
    if (o3_delayid > 0)
        clearTimeout(o3_delayid);
    o3_timerid = 0;
    o3_delayid = 0;
    self.status = "";
    if (obj.onmouseout || obj.onmouseover) {

        if (olNs4)
            obj.releaseEvents(Event.MOUSEOUT || Event.MOUSEOVER);
        obj.onmouseout = obj.onmouseover = null;
    }



    runHook("hideObject", FAFTER);
}



// Move a layer

function repositionTo(obj, xL, yL) {

    var theObj = (olNs4 ? obj : obj.style);
    theObj.left = xL + (!olNs4 ? 'px' : 0);
    theObj.top = yL + (!olNs4 ? 'px' : 0);
}



// Check position of cursor relative to overDiv DIVision; mouseOut function

function cursorOff() {

    var left = parseInt(over.style.left);
    var top = parseInt(over.style.top);
    var right = left + (over.offsetWidth >= parseInt(o3_width) ? over.offsetWidth : parseInt(o3_width));
    var bottom = top + (over.offsetHeight >= o3_aboveheight ? over.offsetHeight : o3_aboveheight);
    if (o3_x < left || o3_x > right || o3_y < top || o3_y > bottom)
        return true;
    return false;
}





////////

// COMMAND FUNCTIONS

////////



// Calls callme or the default function.

function opt_FUNCTION(callme) {

    o3_text = (callme ? (typeof callme === 'string' ? (/.+\(.*\)/.test(callme) ? eval(callme) : callme) : callme()) : (o3_function ? o3_function() : 'No Function'));
    return 0;
}



// Handle hovering

function opt_NOCLOSE(unused) {

    if (!unused)
        o3_close = "";
    if (olNs4) {

        over.captureEvents(Event.MOUSEOUT || Event.MOUSEOVER);
        over.onmouseover = function() {
            if (o3_timerid > 0) {
                clearTimeout(o3_timerid);
                o3_timerid = 0;
            }
        };
        over.onmouseout = function(e) {
            if (olHideDelay)
                hideDelay(olHideDelay);
            else
                cClick(e);
        };
    } else {

        over.onmouseover = function() {
            hoveringSwitch = true;
            if (o3_timerid > 0) {
                clearTimeout(o3_timerid);
                o3_timerid = 0;
            }
        };
    }



    return 0;
}



// Function to scan command line arguments for multiples

function opt_MULTIPLEARGS(i, args, parameter) {

    var k = i, re, pV, str = '';
    for (k = i; k < args.length; k++) {

        if (typeof args[k] === 'number' && args[k] > pmStart)
            break;
        str += args[k] + ',';
    }

    if (str)
        str = str.substring(0, --str.length);
    k--; // reduce by one so the for loop this is in works correctly

    pV = (olNs4 && /cellpad/i.test(parameter)) ? str.split(',')[0] : str;
    eval(parameter + '="' + pV + '"');
    return k;
}



// Remove &nbsp; in texts when done.

function nbspCleanup() {

    if (o3_wrap) {

        o3_text = o3_text.replace(/\&nbsp;/g, ' ');
        o3_cap = o3_cap.replace(/\&nbsp;/g, ' ');
    }

}



// Escape embedded single quotes in text strings

function escSglQuote(str) {

    return str.toString().replace(/'/g, "\\'");
}



// Onload handler for window onload event

function OLonLoad_handler(e) {

    var re = /\w+\(.*\)[;\s]+/g, olre = /overlib\(|nd\(|cClick\(/, fn, l, i;
    if (!olLoaded)
        olLoaded = 1;
    // Remove it for Gecko based browsers

    if (window.removeEventListener && e.eventPhase === 3)
        window.removeEventListener("load", OLonLoad_handler, false);
    else if (window.detachEvent) { // and for IE and Opera 4.x but execute calls to overlib, nd, or cClick()

        window.detachEvent("onload", OLonLoad_handler);
        var fN = document.body.getAttribute('onload');
        if (fN) {

            fN = fN.toString().match(re);
            if (fN && fN.length) {

                for (i = 0; i < fN.length; i++) {

                    if (/anonymous/.test(fN[i]))
                        continue;
                    while ((l = fN[i].search(/\)[;\s]+/)) !== -1) {

                        fn = fN[i].substring(0, l + 1);
                        fN[i] = fN[i].substring(l + 2);
                        if (olre.test(fn))
                            eval(fn);
                    }

                }

            }

        }

    }

}



// Wraps strings in Layer Generation Functions with the correct tags

//    endWrap true(if end tag) or false if start tag

//    fontSizeStr - font size string such as '1' or '10px'

//    whichString is being wrapped -- 'text', 'caption', or 'close'

function wrapStr(endWrap, fontSizeStr, whichString) {

    var fontStr, fontColor, isClose = ((whichString === 'close') ? 1 : 0), hasDims = /[%\-a-z]+$/.test(fontSizeStr);
    fontSizeStr = (olNs4) ? (!hasDims ? fontSizeStr : '1') : fontSizeStr;
    if (endWrap)
        return (hasDims && !olNs4) ? (isClose ? '</span>' : '</div>') : '</font>';
    else {

        fontStr = 'o3_' + whichString + 'font';
        fontColor = 'o3_' + ((whichString === 'caption') ? 'cap' : whichString) + 'color';
        return (hasDims && !olNs4) ? (isClose ? '<span style="font-family: ' + quoteMultiNameFonts(eval(fontStr)) + '; color: ' + eval(fontColor) + '; font-size: ' + fontSizeStr + ';">' : '<div style="font-family: ' + quoteMultiNameFonts(eval(fontStr)) + '; color: ' + eval(fontColor) + '; font-size: ' + fontSizeStr + ';">') : '<font face="' + eval(fontStr) + '" color="' + eval(fontColor) + '" size="' + (parseInt(fontSizeStr) > 7 ? '7' : fontSizeStr) + '">';
    }

}



// Quotes Multi word font names; needed for CSS Standards adherence in font-family

function quoteMultiNameFonts(theFont) {

    var v, pM = theFont.split(',');
    for (var i = 0; i < pM.length; i++) {

        v = pM[i];
        v = v.replace(/^\s+/, '').replace(/\s+$/, '');
        if (/\s/.test(v) && !/['"]/.test(v)) {

            v = "\'" + v + "\'";
            pM[i] = v;
        }

    }

    return pM.join();
}



// dummy function which will be overridden 

function isExclusive(args) {

    return false;
}



// Sets cellpadding style string value

function setCellPadStr(parameter) {

    var Str = '', j = 0, ary = new Array(), top, bottom, left, right;
    Str += 'padding: ';
    ary = parameter.replace(/\s+/g, '').split(',');
    switch (ary.length) {

        case 2:

            top = bottom = ary[j];
            left = right = ary[++j];
            break;
        case 3:

            top = ary[j];
            left = right = ary[++j];
            bottom = ary[++j];
            break;
        case 4:

            top = ary[j];
            right = ary[++j];
            bottom = ary[++j];
            left = ary[++j];
            break;
    }



    Str += ((ary.length === 1) ? ary[0] + 'px;' : top + 'px ' + right + 'px ' + bottom + 'px ' + left + 'px;');
    return Str;
}



// function will delay close by time milliseconds

function hideDelay(time) {

    if (time && !o3_delay) {

        if (o3_timerid > 0)
            clearTimeout(o3_timerid);
        o3_timerid = setTimeout("cClick()", (o3_timeout = time));
    }

}



// Was originally in the placeLayer() routine; separated out for future ease

function horizontalPlacement(browserWidth, horizontalScrollAmount, widthFix) {

    var placeX, iwidth = browserWidth, winoffset = horizontalScrollAmount;
    var parsedWidth = parseInt(o3_width);
    if (o3_fixx > -1 || o3_relx !== null) {

// Fixed position

        placeX = (o3_relx !== null ? (o3_relx < 0 ? winoffset + o3_relx + iwidth - parsedWidth - widthFix : winoffset + o3_relx) : o3_fixx);
    } else {

// If HAUTO, decide what to use.

        if (o3_hauto === 1) {

            if ((o3_x - winoffset) > (iwidth / 2)) {

                o3_hpos = LEFT;
            } else {

                o3_hpos = RIGHT;
            }

        }



// From mouse

        if (o3_hpos === CENTER) { // Center

            placeX = o3_x + o3_offsetx - (parsedWidth / 2);
            if (placeX < winoffset)
                placeX = winoffset;
        }



        if (o3_hpos === RIGHT) { // Right

            placeX = o3_x + o3_offsetx;
            if ((placeX + parsedWidth) > (winoffset + iwidth - widthFix)) {

                placeX = iwidth + winoffset - parsedWidth - widthFix;
                if (placeX < 0)
                    placeX = 0;
            }

        }

        if (o3_hpos === LEFT) { // Left

            placeX = o3_x - o3_offsetx - parsedWidth;
            if (placeX < winoffset)
                placeX = winoffset;
        }



// Snapping!

        if (o3_snapx > 1) {

            var snapping = placeX % o3_snapx;
            if (o3_hpos === LEFT) {

                placeX = placeX - (o3_snapx + snapping);
            } else {

// CENTER and RIGHT

                placeX = placeX + (o3_snapx - snapping);
            }



            if (placeX < winoffset)
                placeX = winoffset;
        }

    }



    return placeX;
}



// was originally in the placeLayer() routine; separated out for future ease

function verticalPlacement(browserHeight, verticalScrollAmount) {

    var placeY, iheight = browserHeight, scrolloffset = verticalScrollAmount;
    var parsedHeight = (o3_aboveheight ? parseInt(o3_aboveheight) : (olNs4 ? over.clip.height : over.offsetHeight));
    if (o3_fixy > -1 || o3_rely !== null) {

// Fixed position

        placeY = (o3_rely !== null ? (o3_rely < 0 ? scrolloffset + o3_rely + iheight - parsedHeight : scrolloffset + o3_rely) : o3_fixy);
    } else {

// If VAUTO, decide what to use.

        if (o3_vauto === 1) {

            if ((o3_y - scrolloffset) > (iheight / 2) && o3_vpos === BELOW && (o3_y + parsedHeight + o3_offsety - (scrolloffset + iheight) > 0)) {

                o3_vpos = ABOVE;
            } else if (o3_vpos === ABOVE && (o3_y - (parsedHeight + o3_offsety) - scrolloffset < 0)) {

                o3_vpos = BELOW;
            }

        }



// From mouse

        if (o3_vpos === ABOVE) {

            if (o3_aboveheight === 0)
                o3_aboveheight = parsedHeight;
            placeY = o3_y - (o3_aboveheight + o3_offsety);
            if (placeY < scrolloffset)
                placeY = scrolloffset;
        } else {

// BELOW

            placeY = o3_y + o3_offsety;
        }



// Snapping!

        if (o3_snapy > 1) {

            var snapping = placeY % o3_snapy;
            if (o3_aboveheight > 0 && o3_vpos === ABOVE) {

                placeY = placeY - (o3_snapy + snapping);
            } else {

                placeY = placeY + (o3_snapy - snapping);
            }



            if (placeY < scrolloffset)
                placeY = scrolloffset;
        }

    }



    return placeY;
}



// checks positioning flags

function checkPositionFlags() {

    if (olHautoFlag)
        olHautoFlag = o3_hauto = 0;
    if (olVautoFlag)
        olVautoFlag = o3_vauto = 0;
    return true;
}



// get Browser window width

function windowWidth() {

    var w;
    if (o3_frame.innerWidth)
        w = o3_frame.innerWidth;
    else if (eval('o3_frame.' + docRoot) && eval("typeof o3_frame." + docRoot + ".clientWidth=='number'") && eval('o3_frame.' + docRoot + '.clientWidth'))
        w = eval('o3_frame.' + docRoot + '.clientWidth');
    return w;
}



// create the div container for popup content if it doesn't exist

function createDivContainer(id, frm, zValue) {

    id = (id || 'overDiv'), frm = (frm || o3_frame), zValue = (zValue || 1000);
    var objRef, divContainer = layerReference(id);
    if (divContainer === null) {

        if (olNs4) {

            divContainer = frm.document.layers[id] = new Layer(window.innerWidth, frm);
            objRef = divContainer;
        } else {

            var body = (olIe4 ? frm.document.all.tags('BODY')[0] : frm.document.getElementsByTagName("BODY")[0]);
            if (olIe4 && !document.getElementById) {

                body.insertAdjacentHTML("beforeEnd", '<div id="' + id + '"></div>');
                divContainer = layerReference(id);
            } else {

                divContainer = frm.document.createElement("DIV");
                divContainer.id = id;
                body.appendChild(divContainer);
            }

            objRef = divContainer.style;
        }



        objRef.position = 'absolute';
        objRef.visibility = 'hidden';
        objRef.zIndex = zValue;
        if (olIe4 && !olOp)
            objRef.left = objRef.top = '0px';
        else
            objRef.left = objRef.top = -10000 + (!olNs4 ? 'px' : 0);
    }



    return divContainer;
}



// get reference to a layer with ID=id

function layerReference(id) {

    return (olNs4 ? o3_frame.document.layers[id] : (document.all ? o3_frame.document.all[id] : o3_frame.document.getElementById(id)));
}

////////

//  UTILITY FUNCTIONS

////////



// Checks if something is a function.

function isFunction(fnRef) {

    var rtn = true;
    if (typeof fnRef === 'object') {

        for (var i = 0; i < fnRef.length; i++) {

            if (typeof fnRef[i] === 'function')
                continue;
            rtn = false;
            break;
        }

    } else if (typeof fnRef !== 'function') {

        rtn = false;
    }



    return rtn;
}



// Converts an array into an argument string for use in eval.

function argToString(array, strtInd, argName) {

    var jS = strtInd, aS = '', ar = array;
    argName = (argName ? argName : 'ar');
    if (ar.length > jS) {

        for (var k = jS; k < ar.length; k++)
            aS += argName + '[' + k + '], ';
        aS = aS.substring(0, aS.length - 2);
    }



    return aS;
}



// Places a hook in the correct position in a hook point.

function reOrder(hookPt, fnRef, order) {

    var newPt = new Array(), match, i, j;
    if (!order || typeof order === 'undefined' || typeof order === 'number')
        return hookPt;
    if (typeof order === 'function') {

        if (typeof fnRef === 'object') {

            newPt = newPt.concat(fnRef);
        } else {

            newPt[newPt.length++] = fnRef;
        }



        for (i = 0; i < hookPt.length; i++) {

            match = false;
            if (typeof fnRef === 'function' && hookPt[i] === fnRef) {

                continue;
            } else {

                for (j = 0; j < fnRef.length; j++)
                    if (hookPt[i] === fnRef[j]) {

                        match = true;
                        break;
                    }

            }

            if (!match)
                newPt[newPt.length++] = hookPt[i];
        }



        newPt[newPt.length++] = order;
    } else if (typeof order === 'object') {

        if (typeof fnRef === 'object') {

            newPt = newPt.concat(fnRef);
        } else {

            newPt[newPt.length++] = fnRef;
        }



        for (j = 0; j < hookPt.length; j++) {

            match = false;
            if (typeof fnRef === 'function' && hookPt[j] === fnRef) {

                continue;
            } else {

                for (i = 0; i < fnRef.length; i++)
                    if (hookPt[j] === fnRef[i]) {

                        match = true;
                        break;
                    }

            }

            if (!match)
                newPt[newPt.length++] = hookPt[j];
        }



        for (i = 0; i < newPt.length; i++)
            hookPt[i] = newPt[i];
        newPt.length = 0;
        for (j = 0; j < hookPt.length; j++) {

            match = false;
            for (i = 0; i < order.length; i++) {

                if (hookPt[j] === order[i]) {

                    match = true;
                    break;
                }

            }

            if (!match)
                newPt[newPt.length++] = hookPt[j];
        }

        newPt = newPt.concat(order);
    }



    hookPt = newPt;
    return hookPt;
}



////////

//  PLUGIN ACTIVATION FUNCTIONS

////////



// Runs plugin functions to set runtime variables.

function setRunTimeVariables() {

    if (typeof runTime !== 'undefined' && runTime.length) {

        for (var k = 0; k < runTime.length; k++) {

            runTime[k]();
        }

    }

}



// Runs plugin functions to parse commands.

function parseCmdLine(pf, i, args) {

    if (typeof cmdLine !== 'undefined' && cmdLine.length) {

        for (var k = 0; k < cmdLine.length; k++) {

            var j = cmdLine[k](pf, i, args);
            if (j > -1) {

                i = j;
                break;
            }

        }

    }



    return i;
}



// Runs plugin functions to do things after parse.

function postParseChecks(pf, args) {

    if (typeof postParse !== 'undefined' && postParse.length) {

        for (var k = 0; k < postParse.length; k++) {

            if (postParse[k](pf, args))
                continue;
            return false; // end now since have an error

        }

    }

    return true;
}





////////

//  PLUGIN REGISTRATION FUNCTIONS

////////



// Registers commands and creates constants.

function registerCommands(cmdStr) {

    if (typeof cmdStr !== 'string')
        return;
    var pM = cmdStr.split(',');
    pms = pms.concat(pM);
    for (var i = 0; i < pM.length; i++) {

        eval(pM[i].toUpperCase() + '=' + pmCount++);
    }

}



// Registers no-parameter commands

function registerNoParameterCommands(cmdStr) {

    if (!cmdStr && typeof cmdStr !== 'string')
        return;
    pmt = (!pmt) ? cmdStr : pmt + ',' + cmdStr;
}



// Register a function to hook at a certain point.

function registerHook(fnHookTo, fnRef, hookType, optPm) {
    var hookPt, last = typeof optPm;
    if (fnHookTo === 'plgIn' || fnHookTo === 'postParse')
        return;
    if (typeof hookPts[fnHookTo] === 'undefined')
        hookPts[fnHookTo] = new FunctionReference();
    hookPt = hookPts[fnHookTo];
    if (hookType !== null) {
        if (hookType === FREPLACE) {

            hookPt.ovload = fnRef; // replace normal overlib routine
            if (fnHookTo.indexOf('ol_content_') > -1)
                hookPt.alt[pms[CSSOFF - 1 - pmStart]] = fnRef;
        } else if (hookType === FBEFORE || hookType === FAFTER) {

            var hookPt = (hookType === 1 ? hookPt.before : hookPt.after);
            if (typeof fnRef === 'object') {
                hookPt = hookPt.concat(fnRef);
            } else {
                hookPt[hookPt.length++] = fnRef;
            }
            if (optPm)
                hookPt = reOrder(hookPt, fnRef, optPm);
        } else if (hookType === FALTERNATE) {
            if (last === 'number')
                hookPt.alt[pms[optPm - 1 - pmStart]] = fnRef;
        } else if (hookType === FCHAIN) {
            hookPt = hookPt.chain;
            if (typeof fnRef === 'object')
                hookPt = hookPt.concat(fnRef); // add other functions 
            else
                hookPt[hookPt.length++] = fnRef;
        }

        return;
    }
}

// Register a function that will set runtime variables.
function registerRunTimeFunction(fn) {
    if (isFunction(fn)) {
        if (typeof fn === 'object') {
            runTime = runTime.concat(fn);
        } else {
            runTime[runTime.length++] = fn;
        }
    }
}

// Register a function that will handle command parsing.
function registerCmdLineFunction(fn) {
    if (isFunction(fn)) {
        if (typeof fn === 'object') {
            cmdLine = cmdLine.concat(fn);
        } else {
            cmdLine[cmdLine.length++] = fn;
        }
    }
}

// Register a function that does things after command parsing. 
function registerPostParseFunction(fn) {
    if (isFunction(fn)) {
        if (typeof fn === 'object') {
            postParse = postParse.concat(fn);
        } else {
            postParse[postParse.length++] = fn;
        }
    }
}

////////
//  PLUGIN REGISTRATION FUNCTIONS
////////
// Runs any hooks registered.
function runHook(fnHookTo, hookType) {
    var l = hookPts[fnHookTo], k, rtnVal = null, optPm, arS, ar = runHook.arguments;
    if (hookType === FREPLACE) {
        arS = argToString(ar, 2);
        if (typeof l === 'undefined' || !(l = l.ovload))
            rtnVal = eval(fnHookTo + '(' + arS + ')');
        else
            rtnVal = eval('l(' + arS + ')');
    } else if (hookType === FBEFORE || hookType === FAFTER) {
        if (typeof l !== 'undefined') {
            l = (hookType === 1 ? l.before : l.after);
            if (l.length) {
                arS = argToString(ar, 2);
                for (var k = 0; k < l.length; k++)
                    eval('l[k](' + arS + ')');
            }
        }
    } else if (hookType === FALTERNATE) {
        optPm = ar[2];
        arS = argToString(ar, 3);
        if (typeof l === 'undefined' || (l = l.alt[pms[optPm - 1 - pmStart]]) === 'undefined') {
            rtnVal = eval(fnHookTo + '(' + arS + ')');
        } else {
            rtnVal = eval('l(' + arS + ')');
        }
    } else if (hookType === FCHAIN) {
        arS = argToString(ar, 2);
        l = l.chain;
        for (k = l.length; k > 0; k--)
            if ((rtnVal = eval('l[k-1](' + arS + ')')) !== void(0))
                break;
    }

    return rtnVal;
}

////////
// OBJECT CONSTRUCTORS
////////

// Object for handling hooks.
function FunctionReference() {
    this.ovload = null;
    this.before = new Array();
    this.after = new Array();
    this.alt = new Array();
    this.chain = new Array();
}

// Object for simple access to the overLIB version used.
// Examples: simpleversion:351 major:3 minor:5 revision:1
function Info(version, prerelease) {
    this.version = version;
    this.prerelease = prerelease;
    this.simpleversion = Math.round(this.version * 100);
    this.major = parseInt(this.simpleversion / 100);
    this.minor = parseInt(this.simpleversion / 10) - this.major * 10;
    this.revision = parseInt(this.simpleversion) - this.major * 100 - this.minor * 10;
    this.meets = meets;
}

// checks for Core Version required
function meets(reqdVersion) {
    return (!reqdVersion) ? false : this.simpleversion >= Math.round(100 * parseFloat(reqdVersion));
}


////////
// STANDARD REGISTRATIONS
////////
registerHook("ol_content_simple", ol_content_simple, FALTERNATE, CSSOFF);
registerHook("ol_content_caption", ol_content_caption, FALTERNATE, CSSOFF);
registerHook("ol_content_background", ol_content_background, FALTERNATE, CSSOFF);
registerHook("ol_content_simple", ol_content_simple, FALTERNATE, CSSCLASS);
registerHook("ol_content_caption", ol_content_caption, FALTERNATE, CSSCLASS);
registerHook("ol_content_background", ol_content_background, FALTERNATE, CSSCLASS);
registerPostParseFunction(checkPositionFlags);
registerHook("hideObject", nbspCleanup, FAFTER);
registerHook("horizontalPlacement", horizontalPlacement, FCHAIN);
registerHook("verticalPlacement", verticalPlacement, FCHAIN);
if (olNs4 || (olIe5 && isMac) || olKq)
    olLoaded = 1;
registerNoParameterCommands('sticky,autostatus,autostatuscap,fullhtml,hauto,vauto,closeclick,wrap,followmouse,mouseoff,compatmode');
///////
// ESTABLISH MOUSECAPTURING
///////
// Capture events, alt. diffuses the overlib function.
var olCheckMouseCapture = true;
if ((olNs4 || olNs6 || olIe4)) {
    olMouseCapture();
} else {
    overlib = no_overlib;
    nd = no_overlib;
    ver3fix = true;
}


///////////////////////////////////
// TIME: Device time in #time in readable format
///////////////////////////////////
function time() {

    $.getJSON("/lib/get_time_info.html", function (data)
    {   
        var timezone = data["_TIME_ZONE"][0];
        var systime = new Date(data["_SYSTIME"][0] * 1000);                                  
        var utctime = new Date(data["_UTCTIME"][0] * 1000);      
        var offset=  (systime-utctime)/1000;
          
    
        /* systime enth�lt vom Jasic her schon die Zeitzone und das Sommerzeit-Offset, JavaScript rechnet dies aber anscheinend donnoch nochmal ein.
        Deshalb */
       
        systime.setSeconds(-offset);
        var year = systime.getYear();
        year = year + 1900;
        var month = systime.getMonth();
        month = month + 1;
        var day = systime.getDate();
        var hour = systime.getHours();
  
        var minute = systime.getMinutes();
        var StdHour = ((hour < 10) ? "0" + hour : hour);
        var StdMin = ((minute < 10) ? "0" + minute : minute);
        var StdDay = ((day < 10) ? "0" + day : day);
        var StdMonth = ((month < 10) ? "0" + month : month);
        var gmttime = (offset/3600);
        
        gmttime = Math.round(gmttime);
        
        if(gmttime >= 0){
            $('#time').text(StdHour + ":" + StdMin + " / " + StdDay + "." + StdMonth + "." + year + " (UTC+" + gmttime + ")");
        }else{
            $('#time').text(StdHour + ":" + StdMin + " / " + StdDay + "." + StdMonth + "." + year + " (UTC" + gmttime + ")");
        }
    });
}