const mapFlagsToReasonOfTransient = require("../../../html/lib/transients/transients").mapFlagsToReasonOfTransient;
const bittest = require("../../../html/lib/transients/transients").bittest;

const cases = [
    [0x00000001,  0, "transient.current"],              [0x0000000F, 0, "transient.current"],           [0x00000001, 3, "transient.current"],
    [0x00000010,  0, "transient.voltage"],              [0x000000F0, 0, "transient.voltage"],
    [0X00000100,  0, "transient.reasonundefined"],      [0x00000F00, 0, "transient.reasonundefined"],
    [0x00001000,  0, "transient.event"],                [0x0000F000, 0, "transient.event"],
    [0x00010000,  0, "transient.voltagedelta"],         [0x000F0000, 0, "transient.voltagedelta"],
    [0X00100000,  0, "transient.reasonundefined"],      [0x00F00000, 0, "transient.reasonundefined"],
    [0x01000000,  0, "transient.voltageenvelope"],      [0x0F000000, 0, "transient.voltageenvelope"], 
    [0x10000000,  4, "transient.kwhigh"],               [0xF0000000, 4, "transient.kwhigh"],            [0x30000000, 4, "transient.kwhigh"],
    [0x10000000,  5, "transient.kwhighend"],            [0xF0000000, 5, "transient.kwhighend"],
    [0x10000000,  6, "transient.kvahigh"],              [0xF0000000, 6, "transient.kvahigh"],
    [0x10000000,  7, "transient.kvahighend"],           [0xF0000000, 7, "transient.kvahighend"],
    [0x10000000,  8, "transient.voltageunbalance"],     [0xF0000000, 8, "transient.voltageunbalance"],
    [0x10000000,  9, "transient.voltageunbalanceend"],  [0xF0000000, 9, "transient.voltageunbalanceend"],
    [0x10000000, 10, "transient.voltagethd"],           [0xF0000000, 10, "transient.voltagethd"],
    [0x10000000, 11, "transient.voltagethdend"],        [0xF0000000, 11, "transient.voltagethdend"]
];

describe("test mapFlagsToReasonOfTransient", () => {
    test.each(cases)(
        "given %p and %p as arguments, returns %p",
        (flag, enumflag, expectedReason) => {
            const result = mapFlagsToReasonOfTransient(flag, enumflag);
            expect(result).toEqual(expectedReason);
        }
    );
});

const bittestData = [
    [0x00004001,  14, true], [0x00004010,  14, true], [0x00004100,  14, true], [0x00000001,  14, false], [0x00034000,  14, true],
    [0x00030000,  14, false], [0x01004001, 0, true], [0x01004000, 0, false], [0x11004000, 28, true], [0x01004000, 28, false]
];

describe("test bittest function", () => {
    test.each(bittestData)(
        "given %p and %p as arguments, returns %p",
        (number, nth, expectedResult) => {
            const result = bittest(number, nth);
            expect(result).toEqual(expectedResult);
        }
    );
});